#if !defined(AFX_DEVICEPAGE_H__3C18034F_CA51_4E59_8B95_61289FA66EC9__INCLUDED_)
#define AFX_DEVICEPAGE_H__3C18034F_CA51_4E59_8B95_61289FA66EC9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DevicePage.h : header file
//

#include "OptionPage.h"

/////////////////////////////////////////////////////////////////////////////
// CDevicePage dialog

class CDevicePage : public COptionPage
{
// Construction
public:
	CDevicePage(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDevicePage)
	enum { IDD = IDD_DEVICE_PAGE };
	int		m_nGpio;
	UINT	m_nGpioBit;
	CString	m_i2cReadAddr;
	CString	m_i2cReadData;
	CString	m_i2cWriteData;
	int		m_nGpioMode;
	UINT	m_nReadBytes;
	CString	m_regVideo;
	CString	m_valVideo;
	CString	m_regAudio;
	CString	m_valAudio;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDevicePage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HANDLE m_hGpio;
	HANDLE m_hI2C;
	HANDLE m_hDevice;
	HANDLE m_hDeviceAudio;

	// Generated message map functions
	//{{AFX_MSG(CDevicePage)
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnRadioGpioOut0();
	afx_msg void OnRadioGpioOut1();
	afx_msg void OnBtnGpioRead();
	afx_msg void OnSelchangeComboGpio();
	afx_msg void OnBtnI2cread();
	afx_msg void OnBtnI2cwrite();
	afx_msg void OnChangeEditI2cwrite();
	afx_msg void OnChangeEditI2creadAddr();
	afx_msg void OnRadioGpioInput();
	afx_msg void OnBtnRead24c02();
	afx_msg void OnBtnVideoRegWrite();
	afx_msg void OnBtnVideoRegRead();
	afx_msg void OnBtnAudioRegWrite();
	afx_msg void OnBtnAudioRegRead();
	afx_msg void OnBtnVideoCfgWrite();
	afx_msg void OnBtnVideoCfgRead();
	afx_msg void OnBtnAudioCfgWrite();
	afx_msg void OnBtnAudioCfgRead();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	BOOL Split(CString line, CString sep, CStringArray& strArr);
	BYTE Char2Hex(TCHAR cHex);
	BYTE Str2Byte(CString strHex);

public:
	virtual BOOL SetId(int nId);
	virtual BOOL Apply() { return TRUE; }
	virtual BOOL Apply2() { return TRUE; }
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DEVICEPAGE_H__3C18034F_CA51_4E59_8B95_61289FA66EC9__INCLUDED_)
