// Title.cpp : implementation file
//

#include "stdafx.h"
#include "tw68xx.h"
#include "Title.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTitle dialog


CTitle::CTitle()
{
	//{{AFX_DATA_INIT(CTitle)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_strTitle = TEXT("");
}

CTitle::~CTitle()
{
	DestroyWindow();
}

void CTitle::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTitle)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTitle, CDialog)
	//{{AFX_MSG_MAP(CTitle)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTitle message handlers

BOOL CTitle::CreateWnd(CWnd* pParentWnd, COLORREF color)
{
	m_bkBrush.CreateSolidBrush(color);
	
	if(!Create(IDD_BORDER_DIALOG, pParentWnd)) {
		return FALSE;
	}

	CPaintDC dc(this); // device context for painting
	CString  strTitle;
	CSize	 siz;
	CRect	 rc;
	
	strTitle.Format(IDS_TITLE, 0, 0);
	siz = dc.GetTextExtent(strTitle);
	GetWindowRect(&rc);
	rc.right = rc.left+siz.cx+2;
	rc.bottom= rc.top+siz.cy+2;
	MoveWindow(&rc);

	return TRUE;
}

HBRUSH CTitle::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	return m_bkBrush;
}

void CTitle::OnOK() 
{
}

void CTitle::OnCancel() 
{
}

void CTitle::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	dc.TextOut(0, 0, m_strTitle);
}

void CTitle::UpdateTitle(CString strTitle)
{
	m_strTitle=strTitle;

	Invalidate();
}