//////////////////////////////////////////////////////////////////////
// IniFile.h: interface for the CIniFile class.
// Copyright (c) 2006-2008 liran, ShareBit							//
//////////////////////////////////////////////////////////////////////

#if !defined(__INIFILE_H__)
#define __INIFILE_H__

class CIniFile
{
public:
	CIniFile(){};
	~CIniFile(){};

public:
	void Create(LPCTSTR filename){lstrcpy(m_filename, filename);}
	BOOL ReadStruct(LPCTSTR Section, LPCTSTR Key, LPVOID lpStruct, UINT uSizeStruct)
	{
		return GetPrivateProfileStruct(Section, Key, lpStruct, uSizeStruct, m_filename);
	}
	LPCTSTR ReadString(LPCTSTR Section, LPCTSTR Key, LPCTSTR szDefault, LPTSTR szVal, int len=256)
	{
		GetPrivateProfileString(Section, Key, szDefault, szVal, len, m_filename);
		return szVal;
	}
	int  ReadInt(LPCTSTR Section, LPCTSTR Key, int nDefault)
	{
		return GetPrivateProfileInt(Section, Key, nDefault, m_filename);
	}
	BOOL WriteStruct(LPCTSTR Section, LPCTSTR Key, LPVOID lpStruct, UINT uSizeStruct)
	{
		return WritePrivateProfileStruct(Section, Key, lpStruct, uSizeStruct, m_filename);
	}
	BOOL WriteString(LPCTSTR Section, LPCTSTR Key, LPCTSTR lpString)
	{
		return WritePrivateProfileString(Section, Key, lpString, m_filename);
	}
	BOOL WriteInt(LPCTSTR Section, LPCTSTR Key, int nValue)
	{
		TCHAR strInt[10];
		wsprintf(strInt, TEXT("%d"), nValue);
		return WritePrivateProfileString(Section, Key, strInt, m_filename);
	}

protected:
	TCHAR m_filename[300];
};


#endif // !defined(__INIFILE_H__)
