//////////////////////////////////////////////////////////////////////
// TimedCallback.h: interface for the CTimedCallback class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__TIMEDCALLBACK_H_)
#define __TIMEDCALLBACK_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CTimedCallback : public KTimedCallback  
{
// Construction
public:
	SAFE_DESTRUCTORS
	CTimedCallback(void);

	// Methods
public:
	virtual BOOLEAN Set(
		LARGE_INTEGER DueTime,
		PKDEFERRED_ROUTINE Callback, 
		PVOID Context,
		PVOID Arg1, 
		PVOID Arg2);
	
	virtual BOOLEAN Set(
		LONGLONG DueTime,
		PKDEFERRED_ROUTINE Callback, 
		PVOID Context,
		PVOID Arg1, 
		PVOID Arg2);
	
	virtual BOOLEAN SetPeriodic(
		LARGE_INTEGER DueTime, 
		LONG PeriodmSec,
		PKDEFERRED_ROUTINE Callback, 
		PVOID Context,
		PVOID Arg1, 
		PVOID Arg2);

	virtual BOOLEAN SetPeriodic(
		LONGLONG DueTime, 
		LONG PeriodmSec,
		PKDEFERRED_ROUTINE Callback, 
		PVOID Context,
		PVOID Arg1, 
		PVOID Arg2);
};

#endif // !defined(__TIMEDCALLBACK_H_)
