//////////////////////////////////////////////////////////////////////
// WavePacket.h: interface for the CWavePacket class.
//////////////////////////////////////////////////////////////////////

#if !defined(__WAVEPACKET_H_)
#define __WAVEPACKET_H_

class CWavePacket
{
public:
	CWavePacket();
	virtual ~CWavePacket();
	
	BOOL		Initialize(ULONG len);
	BOOL		Initialize(PBYTE pBuff, ULONG len);
	void		Invalidate();
	LPWAVEHDR	WaveHdr(){return &m_hdr;}
	void		SetBusy(BOOL isBusy){m_isBusy=isBusy;}
	BOOL		IsBusy(){return m_isBusy;}
	PBYTE		Buffer(){return m_pBuff;}		
	
protected:
	WAVEHDR	m_hdr;
	PBYTE	m_pBuff;
	BOOL	m_isAlloc;
	ULONG	m_bufLen;
	BOOL	m_isBusy;
};

#endif // !defined(__SAMPLE_H_)
