/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6864.h
 *  @brief		豸CDev6864ʵ֣֧TW6864
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#if !defined(__DEV6864_H_)
#define __DEV6864_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DevBase.h"

#define P_TW6864						((CTW6864*)m_pParent)

class CDev6864 : public CDevBase  
{
public:
	CDev6864();
	virtual ~CDev6864();

	virtual long PrepareRun();
	virtual BOOL OnData();
	virtual long HasSignal();
	virtual int  DeviceType() {return DEV_video;}
	virtual BOOL HasChannelRunning(ULONG runFlag); 
	virtual BOOL OnDmaError(ULONG status1, ULONG status2, PVOID ctx);
	virtual void SetFrameRate(void* ctx) {}
	int			 BadFrames(){ return m_iBadFrames; }
	void		 ResetBadFrames() { m_iBadFrames=0; }

protected:
	//麯ʼʼ豸
	virtual BOOL OnFreeResource();
	virtual BOOL OnClose();
	virtual void Build(void* ctx) {}
	virtual BOOL Y420ToYuv420p(PBYTE y420, PBYTE yuv420p, BOOL bFiled2, void* ctx);
	virtual BOOL Y41PToYuv420p(PBYTE y41p, PBYTE yuv420p, BOOL bFiled2, void* ctx);
	virtual BOOL Y411ToYuv420p(PBYTE y411, PBYTE yuv420p, BOOL bFiled2, void* ctx);

	//DMAP
	virtual void RunDmap(UCHAR run);

	int			m_iCheck;
	int			m_iBadFrames;
	LONGLONG	m_tkLast;
};

#endif // !defined(__DEV6864_H_)
