/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6869aud.h
 *  @brief		豸CDev6869aud֧TW6869 audio
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/07/10
 ***************************************************************************************
 */

#if !defined(__DEV6869AUD_H_)
#define __DEV6869AUD_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DevBase.h"

class CDev6869aud : public CDevBase  
{
public:
	CDev6869aud();
	virtual ~CDev6869aud();

	virtual long PrepareRun();
	virtual BOOL OnData();
	virtual long OnIrq();
	virtual int  DeviceType() {return DEV_audio;}
	virtual BOOL ModifyEvt(HANDLE hEvent);
	virtual BOOL OnDmaError(ULONG status1, ULONG status2, PVOID ctx);
	virtual void OnDmaTimeOut();
	
protected:
	//麯ʼʼ豸
	virtual BOOL OnAllocResource();
	virtual BOOL OnFreeResource();
	virtual BOOL OnOpen();
	virtual BOOL OnClose();
	
	//DMAP
	virtual void RunDmap(UCHAR run);
};

#endif // !defined(__DEV6869AUD_H_)
