//////////////////////////////////////////////////////////////////////
// Sample.cpp: implementation of the CSample class.
// Ƶ֡
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Sample.h"

//CLockCS CSample::m_lock;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSample::CSample() :
m_channel(NULL),
m_state(PLG_none),
m_bAlloc(FALSE),
m_bAppend(FALSE),
m_pts(0),
m_type(0),
m_offset(0)
{
	ZeroMemory(&m_memBuf, sizeof(TMemBlock));
}

CSample::~CSample()
{
	Free();
}

//---------------------------------------------------------------
// ڴ
//---------------------------------------------------------------
BOOL CSample::Allocate(ULONG len)
{
	if(m_bAlloc) {
		return FALSE;
	}

	m_memBuf.vaddr = VirtualAlloc(NULL, len, MEM_RESERVE|MEM_COMMIT, PAGE_READWRITE);
	//m_memBuf.vaddr = aaa_malloc(len+64, 64);
	if(m_memBuf.vaddr == NULL) {
		return FALSE;
	}

	memset(m_memBuf.vaddr, 0, len);
	m_memBuf.len = len;
	m_memBuf.inode = 0;
	m_memBuf.pnodes= NULL;
	m_bAlloc = TRUE;
	m_bAppend= FALSE;

	return TRUE;
}

//---------------------------------------------------------------
// ͷڴ
//---------------------------------------------------------------
void CSample::Free()
{
	if(m_bAlloc) {
		if(!VirtualFree(m_memBuf.vaddr, 0, MEM_RELEASE)) {
			_trace(TEXT("[]CSample::Freeͷڴ0x%08Xʧ,%dֽ\n"), m_memBuf.vaddr, m_memBuf.len);
		}
		//aaa_free(m_memBuf.vaddr);
		m_bAlloc = FALSE;
	}
	ZeroMemory(&m_memBuf, sizeof(TMemBlock));
	m_bAppend = FALSE;
}

BOOL CSample::Append(TMemBlock mb)
{
	if(m_bAlloc) { return FALSE; }
	if(m_memBuf.vaddr != NULL) { return FALSE; }

	m_memBuf = mb;
	m_bAppend = TRUE;

	return TRUE;
}