/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TAssist.h
 *  @brief		߳CTAssist
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/07/29
 ***************************************************************************************
 */

#if !defined(__TASSIST_H_)
#define __TASSIST_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Thread.h"
#include <vector>
using namespace std;

class CDevBase;
class CTAssist : public CThread  
{
public:
	CTAssist();
	virtual ~CTAssist();

	virtual void AppendDevice(CDevBase* dev);
protected:
	virtual UINT DoWork();
	virtual UINT OnExit();
	
	vector<CDevBase*> m_devList;
};

#endif // !defined(__TASSIST_H_)
