/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TCallBack.cpp
 *  @brief		ص߳CTCallbackʵ : еĻص---ԭʼݻصѹݻصƶص
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TCallBack.h"
#include "SafeVector.h"
#include "Sample.h"
#include "Channel.h"
#include "PlgvSource.h"

TwVideoStreamCallback		CTCallback::m_fnStreamV = NULL;
PVOID						CTCallback::m_cxStreamV = NULL;

TwAudioStreamCallback		CTCallback::m_fnStreamA = NULL;
PVOID						CTCallback::m_cxStreamA = NULL;

HWND						CTCallback::m_hWndMsgNotify = NULL;
UINT						CTCallback::m_uMsgNotify	= 0;
int CTCallback::m_nCount = 0;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTCallback::CTCallback() :
m_splCurrent(NULL)
{
	m_nIndex = m_nCount;
	m_nCount++;
}

CTCallback::~CTCallback()
{
}

//-----------------------------------------------------
//̴߳
//-----------------------------------------------------
void CTCallback::OnCreate()
{
	//SetThreadPriority(m_hThread, THREAD_PRIORITY_TIME_CRITICAL);
	//SetThreadPriority(m_hThread, THREAD_PRIORITY_HIGHEST);
	SetThreadPriority(m_hThread, THREAD_PRIORITY_ABOVE_NORMAL);
}

//---------------------------------------------------
// ̹߳
//---------------------------------------------------
UINT CTCallback::DoWork()
{
	DWORD dwWait = 0;
	BOOL  bExit = FALSE;
	CPlugin* plugin = NULL;

	if(!PrepareRun()) {
		return 1;
	}

	while(!bExit) {
		dwWait = WaitForMultipleObjects(EVT_NUM, m_hEvt, FALSE, 10);
		bExit = IsExit();
		if(bExit || (dwWait == (WAIT_OBJECT_0+EVT_EXIT))) {
			break;
		}
		else if(dwWait == WAIT_TIMEOUT) {
//			continue;
		}

		Run();
		ResetEvent(m_hEvt[EVT_DATA]);
	}

	return 0;
}

//-----------------------------------------------------
//ص̹߳
//-----------------------------------------------------
UINT CTCallback::Run()
{
	CSample*	spl = NULL, *dspl = NULL;
	CChannel*	chl	= NULL;
	CPlugin*	plg = NULL;
	ULONG		flag= 0;
	
	//ص
	while(spl=g_cbkList.pop_front(), spl!=NULL) {
		chl = spl->GetChannel();
		flag= spl->Flag();
		if(!chl->IsEnabled(PLG_RunVideoDevice)) { 
			spl->ClearFlag(flag);
			continue; 
		}

		if(flag & PLG_vdecom) {
			dspl = g_bufPlgV.usefor(PLG_vdecom);
			if(dspl != NULL) {
				plg = chl->Plugin(PLG_vdecom);
				if(plg->Transmit(spl, dspl)) {
					spl->ClearFlag(flag);
					dspl->SetFlag(PLG_vrawcbk, PLG_vdecom);
					dspl->SetTimeStamp(spl->TimeStamp());
					dspl->SetType(spl->GetType());
					spl = dspl;
				}
			}
		}
		if(flag & PLG_vrawcbk) {
			//Ƶԭʼݻص
			if(m_fnStreamV) {
				try {
					CPlgvSource* vsource = (CPlgvSource*)chl->Plugin(PLG_vsource);
					TvSourceInfo vinfo = *(PvSourceInfo)vsource->GetPluginInfo();
					if(spl->GetType() == pktVideo) {
						(*m_fnStreamV)(chl->ChannelId(), spl->DataPtr(), vinfo.capture.width, 
							vinfo.capture.height, FALSE, m_cxStreamV, spl->TimeStamp());
					}
					else {
						(*m_fnStreamV)(chl->ChannelId(), spl->DataPtr(), vinfo.preview.width, 
							vinfo.preview.height, TRUE, m_cxStreamV, spl->TimeStamp());
					}
				}
				catch(...) {
					_trace(TEXT("[쳣]CTCallback::Runͨ%dƵԭʼݻص쳣	\
							spl=%08x, datasize=%d\n"), chl->ChannelId(), spl, spl->DataSize());
				}
			}
			spl->ClearFlag(PLG_vrawcbk);
		}
	}

	//Ƶص
	while(spl=g_cbkListA.pop_front(), spl!=NULL) {
		chl = spl->GetChannel();
		if(spl->Flag() & PLG_arawcbk) {
			if(chl->IsEnabled(PLG_arawcbk)) {
				if(m_fnStreamA) {
					try {
						(*m_fnStreamA)(chl->ChannelId(), spl->DataPtr(), spl->DataSize(), m_cxStreamA, spl->TimeStamp());
					}
					catch(...) {
						_trace(TEXT("[쳣]CTCallback::Runͨ%dƵPCMݻص쳣	\
							spl=%08x, datasize=%d\n"), chl->ChannelId(), spl, spl->DataSize());
					}
				}
			}
			spl->ClearFlag(PLG_arawcbk);
		}
	}

	m_splCurrent = NULL;

	return 0;
}

//-----------------------------------------------------
//ص̹߳׼
//-----------------------------------------------------
BOOL CTCallback::PrepareRun()
{
	if(m_hEvt[EVT_DATA] == NULL) {
		return FALSE;
	}

	g_cbkList.SetNotifyEvent(m_hEvt[EVT_DATA]);

	return TRUE;
}

//-----------------------------------------------------
// CTCallback߳˳׼
//-----------------------------------------------------
UINT CTCallback::OnExit()
{
	_trace(TEXT("[Ϣ]CTCallback̰߳%dȫ˳\n"), m_nIndex);
	return 0;
}
