/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TCallBack.h
 *  @brief		ص߳CTCallback
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#if !defined(__TCALLBACK_H_)
#define __TCALLBACK_H_

#include "Thread.h"

class CTCallback : public CThread  
{
public:
	CTCallback();
	virtual ~CTCallback();

	static TwVideoStreamCallback	m_fnStreamV;
	static PVOID					m_cxStreamV;

	static TwAudioStreamCallback	m_fnStreamA;
	static PVOID					m_cxStreamA;

	static HWND						m_hWndMsgNotify;
	static UINT						m_uMsgNotify;

	virtual void Clear() {m_nCount=0;}
	CSample* GetCurrentSample() { return m_splCurrent; }

protected:
	virtual void OnCreate();
	virtual BOOL PrepareRun();
	virtual UINT DoWork();
	virtual UINT Run();
	virtual UINT OnExit();

	CSample*	m_splCurrent;
	int			m_nIndex;
	static int	m_nCount;
};

#endif // !defined(__TCALLBACK_H_)
