/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TSource.h
 *  @brief		Դ߳CTSource
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#if !defined(__TSOURCE_H_)
#define __TSOURCE_H_

#include "Thread.h"
#include <vector>
using namespace std;

class CDevBase;
class CTSource : public CThread  
{
public:
	CTSource();
	virtual ~CTSource();
	
	virtual void Clear() {m_nCount=0;}
	virtual void AppendDevice(CDevBase* dev);
protected:
	virtual void OnCreate();
	virtual UINT DoWork();
	virtual UINT Run();
	virtual UINT OnExit();

	vector<CDevBase*> m_devList;

	int			m_nIndex;
	static int	m_nCount;
};

#endif // !defined(__SOURCE_H_)
