//////////////////////////////////////////////////////////////////////
// TSourceA.cpp: implementation of the CTSourceA class.
// ɼƵݷй
// ûָ豸ֹͣ
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "TSourceA.h"
#include "DevBase.h"

#define SOURCE_TIMEOUT	5

int CTSourceA::m_nCount = 0;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTSourceA::CTSourceA()
{
	m_nIndex = m_nCount;
	m_nCount++;
}

CTSourceA::~CTSourceA()
{
}

void CTSourceA::AppendDevice(CDevBase* dev)
{
	for(UINT i=0; i<m_devList.size(); i++) {
		if(m_devList[i] == dev) {
			return;
		}
	}
	
	m_devList.push_back(dev);
}

//-----------------------------------------------------
//̴߳
//-----------------------------------------------------
void CTSourceA::OnCreate()
{
	//sourceȼԱⵥɼʱͼֻɵص
	//Ҳȱ㣬CPUʺܸʱӰѹplugincallbacḳ߳
	//ֱеRaw bufferռѹOSDȴ
	//ЭĽǽsource߳ȼᵽߣ߳ȼҲ

	//SetThreadPriority(m_hThread, THREAD_PRIORITY_TIME_CRITICAL);

	SetThreadPriority(m_hThread, THREAD_PRIORITY_ABOVE_NORMAL);
}

//-----------------------------------------------------
//ɼ̹߳׼
//-----------------------------------------------------
UINT CTSourceA::DoWork()
{
	DWORD dwWait = 0;
	CDevBase*	dev = NULL;
	UINT		i;
	BOOL		bExit = FALSE;

	for(i=0; i<m_devList.size(); i++) {
		m_devList[i]->ModifyEvt(DataEvent());
	}

	while(!bExit) {
		dwWait = WaitForMultipleObjects(EVT_NUM, m_hEvt, FALSE, SOURCE_TIMEOUT);
		bExit = IsExit();
		if(bExit || (dwWait == (WAIT_OBJECT_0+EVT_EXIT))) {
			break;
		}
		Run();
		ResetEvent(m_hEvt[EVT_DATA]);
	}

	//ֹͣƵ豸
	for(i=0; i<m_devList.size(); i++) {
		dev = m_devList[i];

		dev->UpdateState();
		if(dev->GetState()==DEVSTAT_idle) continue;

		//ֹͣ豸
		dev->Stop();
		_trace(TEXT("[Ϣ]CTSourceA::DoWorkֹͣ(slot %d1豸%d)\n"), 
			dev->Parent()->CardInfo()->nSlot, dev->Parent()->DeviceInfo().DeviceNumber);
	}

	return 0;
}

//--------------------------------------------------
// ߳Ҫ
//--------------------------------------------------
UINT CTSourceA::Run()
{
	CDevBase*	dev	= NULL;
	long		retIrq;
	UINT		i, uRet = 0;
	long		state = 0;

	//ַƵ豸¼
	for(i=0; i<m_devList.size(); i++) {
		dev = m_devList[i];
		if((dev==NULL) || (dev->GetState()==DEVSTAT_idle)) continue;
		
		//IRQ
		retIrq = dev->OnIrq();
		if(retIrq<0) continue;

		//ͣ豸豸״̬Ϊready run
		dev->Pause(TRUE);
	}

	for(i=0; i<m_devList.size(); i++) {
		dev = m_devList[i];
		if((dev==NULL) || (dev->GetState()==DEVSTAT_idle)) continue;
		
		//ַ豸ɼ
		dev->OnData();
	}

	//ֹͣûָƵͨɼ
	for(i=0; i<m_devList.size(); i++) {
		dev = g_devListA[i];
		if(dev==NULL) continue;

		//豸״̬
		dev->UpdateState();
		switch(dev->GetState()) {
		case DEVSTAT_readystop :
			//ֹͣ豸
			dev->Stop();
			_trace(TEXT("[Ϣ]CTSourceA::Runûָ(slot %d1豸%d)ֹͣ\n"), 
				dev->Parent()->CardInfo()->nSlot, dev->Parent()->DeviceInfo().DeviceNumber);
			break;
		case DEVSTAT_readyrun :
			if(dev->PrepareRun()) {
				dev->Run();
			}
			break;
		case DEVSTAT_paused :
			dev->Pause(FALSE);
			break;
		default: 
			continue;
			break;
		}
	}

	return uRet;
}

//-----------------------------------------------------
//source߳˳׼
//-----------------------------------------------------
UINT CTSourceA::OnExit()
{
	_trace(TEXT("[Ϣ]CTSourceA߳%dȫ˳\n"), m_nIndex);
	return 0;
}
