//////////////////////////////////////////////////////////////////////
// TSourceA.h: interface for the CTSourceA class.
// audio source߳
//////////////////////////////////////////////////////////////////////

#if !defined(__TSOURCEA_H_)
#define __TSOURCEA_H_

#include "Thread.h"
#include <vector>
using namespace std;

class CDevBase;
class CTSourceA : public CThread  
{
public:
	CTSourceA();
	virtual ~CTSourceA();
	
	virtual void Clear() {m_nCount=0;}
	virtual void AppendDevice(CDevBase* dev);
protected:
	virtual void OnCreate();
	virtual UINT DoWork();
	virtual UINT Run();
	virtual UINT OnExit();

	vector<CDevBase*> m_devList;

	int			m_nIndex;
	static int	m_nCount;
};

#endif // !defined(__TSOURCEA_H_)
