/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TW6802.h
 *  @brief		оƬCTW6801֧TW6802,TW6805
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/03/31
 ***************************************************************************************
 */

#if !defined(__TW6802_H_)
#define __TW6802_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Chipset.h"

class CTW6802 : public CChipset  
{
public:
	CTW6802();
	virtual ~CTW6802();

	virtual BOOL	  CreateDevices();

protected:
	virtual BOOL	  OnInit();
	virtual BOOL	  OnUninit();
	virtual BOOL	  OnOpen();
	virtual BOOL	  OnOpen(PDeviceCapability devCaps, int iDev, int iType);
	virtual LONG	  Devices(int devType);
};

#endif // !defined(__TW6802_H_)
