// Border.cpp : implementation file
//

#include "stdafx.h"
#include "tw68xx.h"
#include "Border.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define IDC_BORDER		6000

/////////////////////////////////////////////////////////////////////////////
// CBorder

CBorder::CBorder() :
m_bsType(bsLeft)
{
}

CBorder::~CBorder()
{
	DestroyWindow();
}

BEGIN_MESSAGE_MAP(CBorder, CDialog)
	//{{AFX_MSG_MAP(CBorder)
	ON_WM_CTLCOLOR_REFLECT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBorder message handlers

BOOL CBorder::CreateWnd(CWnd* pParentWnd, int bsType, COLORREF color)
{
	CRect rc(0, 0, (bsType<bsLeft) ? 100 : BORDER_BOLD,  (bsType<bsLeft) ? BORDER_BOLD : 100);
	m_bkBrush.CreateSolidBrush(color);
	m_bsType = bsType;
	
	return Create(IDD_BORDER_DIALOG, pParentWnd);
}

HBRUSH CBorder::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	return m_bkBrush;
}

BOOL CBorder::MoveTo(CRect rc)
{
	if(m_bsType < bsLeft) {
		rc.bottom = rc.top + BORDER_BOLD;
	}
	else {
		rc.right  = rc.left + BORDER_BOLD;
	} 

	MoveWindow(&rc);

	return TRUE;
}

void CBorder::OnOK() 
{
}

void CBorder::OnCancel() 
{
}
