#if !defined(AFX_CHANNELPAGE_H__A2731354_06EC_4F3A_A134_B981824082A8__INCLUDED_)
#define AFX_CHANNELPAGE_H__A2731354_06EC_4F3A_A134_B981824082A8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ChannelPage.h : header file
//

#include "OptionPage.h"

/////////////////////////////////////////////////////////////////////////////
// CChannelPage dialog

class CChannelPage : public COptionPage
{
// Construction
public:
	CChannelPage(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CChannelPage)
	enum { IDD = IDD_CHANNEL_PAGE };
	int		m_nHeight;
	int		m_nWidth;
	int		m_nStandard;
	int		m_nVideoSize;
	int		m_nFrameRate;
	int		m_nFrameRate2;
	int		m_nHeight2;
	int		m_nWidth2;
	int		m_nVideoSize2;
	int		m_nPixelFormat;
	int		m_nPixelFormat2;
	BOOL	m_bAudio;
	BOOL	m_bDeinterlace;
	BOOL	m_bOptimizeCIF;
	int		m_nField;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChannelPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CChannelPage)
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnRadioPal();
	afx_msg void OnRadioNtsc();
	afx_msg void OnRadioQcif();
	afx_msg void OnRadioQvga();
	afx_msg void OnRadioCif();
	afx_msg void OnRadio2cif();
	afx_msg void OnRadioVga();
	afx_msg void OnRadio4cif();
	afx_msg void OnChangeEditHeight();
	afx_msg void OnChangeEditWidth();
	afx_msg void OnRadioQcif2();
	afx_msg void OnRadioQvga2();
	afx_msg void OnRadioCif2();
	afx_msg void OnRadio2cif2();
	afx_msg void OnChangeEditHeight2();
	afx_msg void OnChangeEditWidth2();
	afx_msg void OnRadioYv12();
	afx_msg void OnRadioYv122();
	afx_msg void OnRadioYuy2();
	afx_msg void OnRadioYuy22();
	afx_msg void OnRadioRgb555();
	afx_msg void OnRadioRgb565();
	afx_msg void OnRadioRgb24();
	afx_msg void OnRadioY41p();
	afx_msg void OnRadioHalfd1();
	afx_msg void OnRadioD1();
	afx_msg void OnRadioHalfd12();
	afx_msg void OnBtnStartchannel();
	afx_msg void OnBtnStopchannel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void EnableField2(BOOL bEnable, BOOL b4Cif, BOOL bSwitch);
	BOOL DoApply(int nId);

	BOOL m_bField2;
	BOOL m_bSwitch;
		
public:
	virtual BOOL SetId(int nId);
	virtual BOOL Apply();
	virtual BOOL Apply2();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHANNELPAGE_H__A2731354_06EC_4F3A_A134_B981824082A8__INCLUDED_)
