// Field2.h: interface for the CField2 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FIELD2_H__62742248_A68B_403E_A651_AA080736A323__INCLUDED_)
#define AFX_FIELD2_H__62742248_A68B_403E_A651_AA080736A323__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VideoWnd.h"
#include "Thread.h"
#include "Surface.h"
#include "VideoOut.h"

class CField2 : public CVideoWnd, CSurface
{
public:
	CField2();
	virtual ~CField2();

	BOOL Open(int width, int height, int pxlFormat=1, BOOL bY41P=FALSE);
	void Close();
	BOOL OnVideoStream(VOID *DataBuf, int width, int height, __int64 pts);
	void ShowVideo(BOOL bShow);
	BOOL Run(BOOL bRun);
	BOOL IsRunning(){ return m_bRunning; }
	void UpdateStatus();
	virtual BOOL IsVisible(){ return m_bVisible;}

protected:
	virtual void OnSetCurrent();
	virtual void OnShowNormal();
	virtual void OnShowLarge();
	virtual void OnShowFull();

	BOOL   m_bRunning;
	PBYTE  m_bufTemp;
	int	   m_nPixelFormat;

public:
	static CVideoOut* m_vOut;
};

#endif // !defined(AFX_FIELD2_H__62742248_A68B_403E_A651_AA080736A323__INCLUDED_)
