#if !defined(AFX_OPTIONDLG_H__E54A897F_E9C5_4FFC_AF65_6D398A01E6F1__INCLUDED_)
#define AFX_OPTIONDLG_H__E54A897F_E9C5_4FFC_AF65_6D398A01E6F1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OptionDlg.h : header file
//

#include "DevicePage.h"
#include "SubDevicePage.h"
#include "ChannelPage.h"
#include "BoardPage.h"

enum {ITEM_BOARD, ITEM_DEVICE, ITEM_SUBDEVICE, ITEM_CHANNEL};
#define MAKEITEM(t, idx) (((t)<<16) | ((USHORT)idx))
#define ITEMTYPE(item)	 ((item)>>16)
#define ITEMIDX(item)	 ((item)&0xFFFF)

/////////////////////////////////////////////////////////////////////////////
// COptionDlg dialog

class COptionDlg : public CDialog
{
// Construction
public:
	COptionDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(COptionDlg)
	enum { IDD = IDD_OPTION_DIALOG };
	CTreeCtrl	m_Board;
	CString	m_strPath;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	COptionPage*	m_curPage;
	CDevicePage		m_devPage;
	CSubDevicePage	m_subPage;
	CChannelPage	m_chlPage;
	CBoardPage		m_bodPage;

	// Generated message map functions
	//{{AFX_MSG(COptionDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnBtnClose();
	afx_msg void OnSelchangedTreeBoard(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBtnApply();
	afx_msg void OnBtnApply2();
	afx_msg void OnBtnBrowse();
	afx_msg void OnCheckShowtitle();
	afx_msg void OnBtnStartall();
	afx_msg void OnBtnStopall();
	afx_msg void OnBtnOptimizeOn();
	afx_msg void OnBtnOptimizeOff();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	BOOL LoadBoard(ULONG item);
	static BOOL SelFolder(HWND hParent, CString &strFolder);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPTIONDLG_H__E54A897F_E9C5_4FFC_AF65_6D398A01E6F1__INCLUDED_)
