// TW68XXDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "TW68XX.h"
#include "TW68XXDlg.h"
#include "IniFile.h"
#include "OptionDlg.h"
#include "VideoOut.h"
#include "BlackStripeDlg.h"
#include "CopyToDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//ӿȵֵķΧ
#define B_MAX	255
#define B_MIN	0
#define C_MAX	127
#define C_MIN	0
#define S_MAX	127
#define S_MIN	0
#define H_MAX	255
#define H_MIN	0
#define SH_MAX	15
#define SH_MIN	0

#define DEFAULT_B		113
#define DEFAULT_C		56
#define DEFAULT_S		59
#define DEFAULT_H		128
#define DEFAULT_SH		3
#define DEFAULT_WIDTH	352
#define DEFAULT_HEIGHT	240	
#define DEFAULT_FRAMES	30
#define DEFAULT_FIELD2	0
#define DEFAULT_COMPOSITE1	1
#define DEFAULT_COMPOSITE2	0
#define DEFAULT_COMPOSITE3	0
#define DEFAULT_COMPOSITE4	0
#define DEFAULT_AUDIO		0
#define DEFAULT_TITLE		0
#define DEFAULT_AUDIO_PACKET	1000
#define DEFAULT_OPTIMIZE_CIF	0
#define DEFAULT_DEINTERLACE		0

#define TIMER_WATCHDOG		1997
#define TIMER_CHECKSIGNAL	1998
#define TIMER_UPDATESTATUS	1999

// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧
	//}}AFX_VIRTUAL

// ʵ
protected:
	// Generated message map functions
	//{{AFX_MSG(CAboutDlg)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CTW68XXDlg Ի

CTW68XXDlg::CTW68XXDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTW68XXDlg::IDD, pParent),
	m_fd2Dlg(m_fd2List)
{
	//{{AFX_DATA_INIT(CTW68XXDlg)
	m_nLayout = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_current= 0;
	m_hSdk	 = NULL;
	m_nAudio = -1;
	m_bLarge = FALSE;
	m_bRunning = FALSE;
	m_fTwSetVideoPara = NULL;
}

void CTW68XXDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTW68XXDlg)
	DDX_Control(pDX, IDC_SLIDER_SHARPNESS, m_sldSharpness);
	DDX_Control(pDX, IDC_SLIDER_SATURATION, m_sldSaturation);
	DDX_Control(pDX, IDC_SLIDER_HUE, m_sldHue);
	DDX_Control(pDX, IDC_SLIDER_CONTRAST, m_sldContrast);
	DDX_Control(pDX, IDC_SLIDER_BRIGHT, m_sldBright);
	DDX_Radio(pDX, IDC_RADIO_4VIDEO, m_nLayout);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTW68XXDlg, CDialog)
	//{{AFX_MSG_MAP(CTW68XXDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CHECK_AUDIO, OnCheckAudio)
	ON_BN_CLICKED(IDC_BTN_OPTION, OnBtnOption)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BTN_DEFAULT, OnBtnDefault)
	ON_BN_CLICKED(IDC_BTN_APPLY2ALL, OnBtnApply2all)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
	ON_BN_CLICKED(IDC_RADIO_4VIDEO, OnRadio4video)
	ON_BN_CLICKED(IDC_RADIO_9VIDEO, OnRadio9video)
	ON_BN_CLICKED(IDC_RADIO_16VIDEO, OnRadio16video)
	ON_BN_CLICKED(IDC_RADIO_36VIDEO, OnRadio36video)
	ON_BN_CLICKED(IDC_RADIO_25VIDEO, OnRadio25video)
	ON_BN_CLICKED(IDC_BTN_FIELD2, OnBtnField2)
	ON_WM_MOVE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_SAVE, OnCheckSave)
	ON_BN_CLICKED(IDC_BTN_SNAP, OnBtnSnap)
	ON_BN_CLICKED(IDC_BTN_2SRCSIZE, OnBtn2srcsize)
	ON_BN_CLICKED(IDC_BTN_BLACKSTRIPE, OnBtnBlackstripe)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

LPCTSTR CTW68XXDlg::GetModulePath(LPTSTR path, int len)
{
	if(path == NULL)
		return NULL;
	
	GetModuleFileName(NULL, path, len);
	
	int   nPathLen = lstrlen(path);
	
	for(int i=nPathLen-1; i>=0; i--)
	{
		if(path[i] == _T('\\'))
		{
			path[i+1] = 0;
			break;
		}
	}
	
	return path;
}

// CTW68XXDlg Ϣ

BOOL CTW68XXDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	ShowWindow(SW_MAXIMIZE);
	m_fd2Dlg.Create(CField2Dlg::IDD, GetDesktopWindow());

	m_sldBright.SetRange(B_MIN, B_MAX);
	m_sldContrast.SetRange(C_MIN, C_MAX);
	m_sldSaturation.SetRange(S_MIN, S_MAX);
	m_sldHue.SetRange(H_MIN, H_MAX);
	m_sldSharpness.SetRange(SH_MIN, SH_MAX);

	if(!InitLogo()) {
		AfxMessageBox(IDS_ERR_INITLOGO);
	}

	if(!InitSDK()) {
		AfxMessageBox(IDS_ERR_INITSDK);
		SendMessage(WM_CLOSE);
		return FALSE;
	}

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CTW68XXDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if(nType==SIZE_MINIMIZED) {
		return;
	}

	CWnd* pOption = GetDlgItem(IDC_BTN_OPTION);
	if(pOption) {
		CRect rcClient;
		int	  nLeft, nTop;
		GetClientRect(&rcClient);

		nLeft = rcClient.left + 10;
		nTop  = rcClient.bottom - 50;
#define BTN_WIDTH	80
		
		GetDlgItem(IDC_BTN_BLACKSTRIPE)->MoveWindow(rcClient.right-BTN_WIDTH*3-3, nTop-9, BTN_WIDTH, 26);
		GetDlgItem(IDC_BTN_FIELD2)->MoveWindow(rcClient.right-BTN_WIDTH*3-3, nTop+18, BTN_WIDTH, 27);

		GetDlgItem(IDC_CHECK_SAVE)->MoveWindow(rcClient.right-BTN_WIDTH*2-2, nTop-9, BTN_WIDTH, 27);
		GetDlgItem(IDC_CHECK_AUDIO)->MoveWindow(rcClient.right-BTN_WIDTH*2-2, nTop+18, BTN_WIDTH, 27);

		pOption->MoveWindow(rcClient.right-BTN_WIDTH-2, nTop-9, BTN_WIDTH, 26);
		GetDlgItem(IDC_BTN_SNAP)->MoveWindow(rcClient.right-BTN_WIDTH-2, nTop+18, BTN_WIDTH, 26);

		GetDlgItem(IDC_STATIC_VIDEOPARA)->MoveWindow(rcClient.left+2, nTop-15, 285, 60);
		GetDlgItem(IDC_STATIC_LAYOUT)->MoveWindow(rcClient.left+290, nTop-15, 260, 60);
		GetDlgItem(IDC_STATIC_BRIGHT)->MoveWindow(nLeft, nTop, 10, 10);
		GetDlgItem(IDC_STATIC_CONTRAST)->MoveWindow(nLeft, nTop+20, 10, 10);
		GetDlgItem(IDC_STATIC_SATURATION)->MoveWindow(nLeft+70, nTop, 10, 10);
		GetDlgItem(IDC_STATIC_HUE)->MoveWindow(nLeft+70, nTop+20, 10, 10);
		GetDlgItem(IDC_STATIC_SHARPNESS)->MoveWindow(nLeft+137, nTop, 15, 10);
		
		m_sldBright.MoveWindow(nLeft+7, nTop, 60, 20);
		m_sldContrast.MoveWindow(nLeft+7, nTop+20, 60, 20);
		m_sldSaturation.MoveWindow(nLeft+77, nTop, 60, 20);
		m_sldHue.MoveWindow(nLeft+77, nTop+20, 60, 20);
		m_sldSharpness.MoveWindow(nLeft+150, nTop, 60, 20);
		
		GetDlgItem(IDC_BTN_DEFAULT)->MoveWindow(nLeft+210, nTop-2, 52, 19);
		GetDlgItem(IDC_BTN_APPLY2ALL)->MoveWindow(nLeft+210, nTop+20, 52, 19);
		GetDlgItem(IDC_RADIO_4VIDEO)->MoveWindow(nLeft+300, nTop, 65, 19);
		GetDlgItem(IDC_RADIO_9VIDEO)->MoveWindow(nLeft+380, nTop, 65, 19);
		GetDlgItem(IDC_RADIO_16VIDEO)->MoveWindow(nLeft+460, nTop, 65, 19);
		GetDlgItem(IDC_RADIO_25VIDEO)->MoveWindow(nLeft+300, nTop+20, 65, 19);
		GetDlgItem(IDC_RADIO_36VIDEO)->MoveWindow(nLeft+380, nTop+20, 65, 19);
		GetDlgItem(IDC_BTN_2SRCSIZE)->MoveWindow(nLeft+460, nTop+20, 65, 19);
		
		rcClient.top = nTop-9;
		InvalidateRect(&rcClient);

		UpdateVideoWnds();
	}
}


void CTW68XXDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);

	UINT i;
	for(i=0; i<m_chlShow.size(); i++) {
		m_chlShow[i]->MoveBorder();
		m_chlShow[i]->MoveTitle();
	}
}

void CTW68XXDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else 
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CTW68XXDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CTW68XXDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

VOID CTW68XXDlg::ShowVideoWnds(int channel, BOOL bShow)
{
	CRect rcClient;
	
	if(channel==-1) {
		for(UINT i=0; i<m_chlShow.size(); i++)
		{
			m_chlShow[i]->ShowVideo(bShow);
		}
		if(bShow) {
			m_chlList[m_current]->ShowBorder(TRUE);
		}
		m_bLarge = !bShow;
		UpdateVideoWnds();
	}
	else if(channel == -3) {
		CRect rc;
		if(bShow) {
			int cxScreen = GetSystemMetrics(SM_CXSCREEN);
			int cyScreen = GetSystemMetrics(SM_CYSCREEN);
			
			GetWindowRect(&rc);
			m_rcNormal= rc;
			rc.top	  = -30;
			rc.left	  = -4;
			rc.right  = cxScreen + 4;
			rc.bottom = cyScreen + 68;
		}
		else {
			rc = m_rcNormal;
		}
		SetWindowPos(&wndTop, rc.left, rc.top, rc.Width(), rc.Height(), SWP_NOZORDER);
		UpdateVideoWnds();
	}
	else {
		if(channel==-2) { channel = m_current; }
		else {
			channel = ChannelIndex(channel);
			if(channel < 0) {
				return;
			}
		}
		m_chlList[channel]->ShowVideo(bShow);
		if(bShow && (channel==m_current)) {
			m_chlList[channel]->ShowBorder(TRUE);
		}
	}
}

//----------------------------------
// õǰͨ
//----------------------------------
VOID CTW68XXDlg::SetCurrentChannel(int channel)
{
	int nLast = m_current;

	if(m_chlList.size() <= 0) {
		return;
	}
	channel = ChannelIndex(channel);
	if(channel < 0) {
		return;
	}

	if((m_current != -1) && (m_current != channel)) {
		m_chlList[m_current]->ShowBorder(FALSE);
	}
	m_current = channel;
	m_chlList[m_current]->ShowBorder(TRUE);

	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(m_hSdk, "TwGetVideoPara");
	if(fTwGetVideoPara == NULL) {
		return;
	}
	
	LONG nValue = 0;
	HANDLE hChannel = m_chlList[m_current]->ChannelHandle();
	
	fTwGetVideoPara(hChannel, vpBrightness, &nValue);
	m_sldBright.SetPos(nValue);
	fTwGetVideoPara(hChannel, vpContrast, &nValue);
	m_sldContrast.SetPos(nValue);
	fTwGetVideoPara(hChannel, vpSaturation, &nValue);
	m_sldSaturation.SetPos(nValue);
	fTwGetVideoPara(hChannel, vpHue, &nValue);
	m_sldHue.SetPos(nValue);
	fTwGetVideoPara(hChannel, vpSharpness, &nValue);
	m_sldSharpness.SetPos(nValue);
	fTwGetVideoPara(hChannel, vpPixelFormat, &nValue);
	
	if(nValue != vpfYUV422Interspersed) {
		((CButton*)GetDlgItem(IDC_CHECK_SAVE))->SetCheck(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_SAVE))->EnableWindow(FALSE);
	}
	else {
		((CButton*)GetDlgItem(IDC_CHECK_SAVE))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_CHECK_SAVE))->SetCheck(m_chlList[m_current]->IsSaving());
	}
	//((CButton*)GetDlgItem(IDC_CHECK_AUDIO))->SetCheck((m_nAudio==m_current));
	if(m_nAudio >= 0) {
		if(m_nAudio != m_current) {
			OnCheckAudio();
		}
	}

	UpdateData(FALSE);
}

//----------------------------------
// ƵRaw dataص
//----------------------------------
int __stdcall CTW68XXDlg::VideoStreamCallback(int nChannel, VOID *DataBuf, int width, int height, BOOL bField2, void *context, __int64 pts)
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)context;
	return pMainDlg->ProcVideoStream(nChannel, DataBuf, width, height, bField2, pts);
}

//----------------------------------
// PCMݻص
//----------------------------------
int __stdcall CTW68XXDlg::AudioStreamCallback(int nChannel, VOID *DataBuf, LONG Length, void *context, __int64 pts)
{
	CTW68XXDlg* pMainDlg = (CTW68XXDlg*)context;
	return pMainDlg->ProcAudioStream(nChannel, DataBuf, Length, pts);
}

int CTW68XXDlg::ProcVideoStream(int nChannel, VOID *DataBuf, int width, int height, BOOL bField2, __int64 pts)
{
	m_bRunning = TRUE;
	try {
		nChannel = ChannelIndex(nChannel);
		if(nChannel < 0) {
			return FALSE;
		}

		if(bField2) {
			if(m_fd2Dlg.IsWindowVisible() && (nChannel<(int)m_fd2List.size()) && (m_fd2List[nChannel]!=NULL)) {
				m_fd2List[nChannel]->OnVideoStream(DataBuf, width, height, pts);
			}
		}
		else if(nChannel < (int)m_chlList.size()) {
			m_chlList[nChannel]->OnVideoStream(DataBuf, width, height, pts, this);
		}
	}
	catch(...) {
	}
	m_bRunning = FALSE;

	return TRUE;
}

int CTW68XXDlg::ProcAudioStream(int nChannel, VOID *DataBuf, LONG Length,  __int64 pts)
{
	m_bRunning = TRUE;

	try {
		nChannel = ChannelIndex(nChannel);
		if(nChannel < 0) {
			return FALSE;
		}

		m_chlList[nChannel]->OnAudioStream(DataBuf, Length, pts);
	}
	catch(...) {
	}
	m_bRunning = FALSE;

	return TRUE;
}

//----------------------------------
// ʼSDK
//----------------------------------
BOOL CTW68XXDlg::InitSDK()
{
	CString	 strInfo;
	CString  strPath;
	CIniFile iniFile;

	GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
	strPath.ReleaseBuffer();
	m_hSdk = LoadLibrary(strPath + TEXT("TW68XX.dll"));
	if(!m_hSdk) {
		AfxMessageBox(IDS_ERR_LOADTW68XX);
		return FALSE;
	}

	TF_TwInitSDK fTwInitSDK = (TF_TwInitSDK)GetProcAddress(m_hSdk, "TwInitSDK");
	if(fTwInitSDK == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	if(!fTwInitSDK()) {
		return FALSE;
	}

	int nBoard = 0;
	int nDevice= 0;
	int nChannel = 0;
	int i = 0;
	ULONG j=0;

	TF_TwGetBoardCount fTwGetBoardCount = (TF_TwGetBoardCount)GetProcAddress(m_hSdk, "TwGetBoardCount");
	if(fTwGetBoardCount == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}
	TF_TwGetBoardHandle fTwGetBoardHandle = (TF_TwGetBoardHandle)GetProcAddress(m_hSdk, "TwGetBoardHandle");
	if(fTwGetBoardHandle == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}
	TF_TwGetBoardDetail fTwGetBoardDetail = (TF_TwGetBoardDetail)GetProcAddress(m_hSdk, "TwGetBoardDetail");
	if(fTwGetBoardDetail == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	nBoard = fTwGetBoardCount();
	if(nBoard <= 0) {
		AfxMessageBox(IDS_ERR_NOBOARD);
		return FALSE;
	}

	TF_TwGetDeviceCount fTwGetDeviceCount = (TF_TwGetDeviceCount)GetProcAddress(m_hSdk, "TwGetDeviceCount");
	if(fTwGetDeviceCount == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	nDevice = fTwGetDeviceCount();
	if(nDevice <= 0) {
		AfxMessageBox(IDS_ERR_NODEVICE);
		return FALSE;
	}

	TF_TwGetDeviceHandle fTwGetDeviceHandle = (TF_TwGetDeviceHandle)GetProcAddress(m_hSdk, "TwGetDeviceHandle");
	if(fTwGetDeviceHandle == NULL) {
		return FALSE;
	}
	
	TF_TwGetDeviceDetail fTwGetDeviceDetail = (TF_TwGetDeviceDetail)GetProcAddress(m_hSdk, "TwGetDeviceDetail");
	if(fTwGetDeviceDetail == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	TF_TwGetSubDeviceCount fTwGetSubDeviceCount = (TF_TwGetSubDeviceCount)GetProcAddress(m_hSdk, "TwGetSubDeviceCount");
	if(fTwGetSubDeviceCount == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	TF_TwGetSubDeviceHandle fTwGetSubDeviceHandle = (TF_TwGetSubDeviceHandle)GetProcAddress(m_hSdk, "TwGetSubDeviceHandle");
	if(fTwGetSubDeviceHandle == NULL) {
		return FALSE;
	}
	
	TF_TwGetSubDeviceDetail fTwGetSubDeviceDetail = (TF_TwGetSubDeviceDetail)GetProcAddress(m_hSdk, "TwGetSubDeviceDetail");
	if(fTwGetSubDeviceDetail == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	TF_TwEnableVideoInput fTwEnableVideoInput = (TF_TwEnableVideoInput)GetProcAddress(m_hSdk, "TwEnableVideoInput");
	if(fTwEnableVideoInput == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}
	
	TF_TwEnableVideoField2 fTwEnableVideoField2 = (TF_TwEnableVideoField2)GetProcAddress(m_hSdk, "TwEnableVideoField2");
	if(fTwEnableVideoField2 == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}
	
	iniFile.Create(strPath + OPTION_FILE);

	int  iReorder	 = iniFile.ReadInt(SECTION_DEFAULT, KEY_REORDER, 0);
	BOOL bFiled2D    = iniFile.ReadInt(SECTION_DEFAULT, KEY_FIELD2, DEFAULT_FIELD2);
	BOOL bComposite1D= iniFile.ReadInt(SECTION_DEFAULT, KEY_COMPOSITE1, DEFAULT_COMPOSITE1);
	BOOL bComposite2D= iniFile.ReadInt(SECTION_DEFAULT, KEY_COMPOSITE2, DEFAULT_COMPOSITE2);
	BOOL bComposite3D= iniFile.ReadInt(SECTION_DEFAULT, KEY_COMPOSITE3, DEFAULT_COMPOSITE3);
	BOOL bComposite4D= iniFile.ReadInt(SECTION_DEFAULT, KEY_COMPOSITE4, DEFAULT_COMPOSITE4);
	BOOL bField2, bComposite1, bComposite2, bComposite3, bComposite4;
	TSubDeviceDesc subDesc;
	TDeviceDesc	   devDesc;
	HANDLE hSubDev = NULL;
	HANDLE hDevice = NULL;

	nDevice = fTwGetSubDeviceCount();
	for(i=0; i<nDevice; i++) {
		ZeroMemory(&subDesc, sizeof(TSubDeviceDesc));
		strInfo.Format(SECTION_SUBDEVICE, i);
		bField2 = iniFile.ReadInt(strInfo, KEY_FIELD2, bFiled2D);
		bComposite1 = iniFile.ReadInt(strInfo, KEY_COMPOSITE1, bComposite1D);
		bComposite2 = iniFile.ReadInt(strInfo, KEY_COMPOSITE2, bComposite2D);
		bComposite3 = iniFile.ReadInt(strInfo, KEY_COMPOSITE3, bComposite3D);
		bComposite4 = iniFile.ReadInt(strInfo, KEY_COMPOSITE4, bComposite4D);

		hSubDev = fTwGetSubDeviceHandle(i);
		fTwEnableVideoField2(hSubDev, bField2);
		fTwEnableVideoInput(hSubDev, viCompositeVideo1, bComposite1);
		fTwEnableVideoInput(hSubDev, viCompositeVideo2, bComposite2);
		fTwEnableVideoInput(hSubDev, viCompositeVideo3, bComposite3);
		fTwEnableVideoInput(hSubDev, viCompositeVideo4, bComposite4);
	}

	TF_TwGetChannelCount fTwGetChannelCount = (TF_TwGetChannelCount)GetProcAddress(m_hSdk, "TwGetChannelCount");
	if(fTwGetChannelCount == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	TF_TwChannelOpen fTwChannelOpen = (TF_TwChannelOpen)GetProcAddress(m_hSdk, "TwChannelOpen");
	if(fTwChannelOpen == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	TF_TwChangeChannelId fTwChangeChannelId = (TF_TwChangeChannelId)GetProcAddress(m_hSdk, "TwChangeChannelId");
	
	TF_TwRegisterVideoStreamCallback fTwRegisterVideoStreamCallback = (TF_TwRegisterVideoStreamCallback)GetProcAddress(m_hSdk, "TwRegisterVideoStreamCallback");
	if(fTwRegisterVideoStreamCallback == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	TF_TwRegisterAudioStreamCallback fTwRegisterAudioStreamCallback = (TF_TwRegisterAudioStreamCallback)GetProcAddress(m_hSdk, "TwRegisterAudioStreamCallback");
	if(fTwRegisterAudioStreamCallback == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	m_fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	if(m_fTwSetVideoPara == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return FALSE;
	}

	fTwRegisterVideoStreamCallback(VideoStreamCallback, this);
	fTwRegisterAudioStreamCallback(AudioStreamCallback, this);

	CChannel* channel = NULL;
	HANDLE    hChannel= NULL;
	int		  k = 0;

	nChannel = fTwGetChannelCount();
	if(nChannel == 0) {
		AfxMessageBox(IDS_ERR_CREATEDEVICE);
		return FALSE;
	}

	if(nChannel==1)						{ k = 1; }
	else if(nChannel>1 && nChannel<=4)	{ k = 2; }
	else if(nChannel>4 && nChannel<=9)	{ k = 3; }
	else if(nChannel>9 && nChannel<=16)	{ k = 4; }
	else if(nChannel>16&& nChannel<=25)	{ k = 5; }
	else if(nChannel>25&& nChannel<=36)	{ k = 6; }
	else if(nChannel>26&& nChannel<=49)	{ k = 7; }
	else								{ k = 8; }
	m_nLayout = k - 2;
	GetDlgItem(IDC_RADIO_36VIDEO)->EnableWindow(!(m_nLayout < 4));
	GetDlgItem(IDC_RADIO_25VIDEO)->EnableWindow(!(m_nLayout < 3));
	GetDlgItem(IDC_RADIO_16VIDEO)->EnableWindow(!(m_nLayout < 2));
	GetDlgItem(IDC_RADIO_9VIDEO)->EnableWindow(!(m_nLayout < 1));

	CRect rcClient;
	GetClientRect(&rcClient);

	int nRightMax = rcClient.right-1;
	int nWidth = rcClient.Width() / k;
	int nHeight= (rcClient.Height()-65) / k;
	int vStandardD = iniFile.ReadInt(SECTION_DEFAULT, KEY_STANDARD, vsStandardNTSC);
	int vFrameRateD= iniFile.ReadInt(SECTION_DEFAULT, KEY_FRAMERATE, DEFAULT_FRAMES);
	int vFormatD= iniFile.ReadInt(SECTION_DEFAULT, KEY_PIXELFORMAT, vpfYUV422Interspersed);
	int vWidthD = iniFile.ReadInt(SECTION_DEFAULT, KEY_WIDTH, DEFAULT_WIDTH);
	int vHeightD= iniFile.ReadInt(SECTION_DEFAULT, KEY_HEIGHT, DEFAULT_HEIGHT);
	int nBrightD= iniFile.ReadInt(SECTION_DEFAULT, KEY_BRIGHT, DEFAULT_B);
	int nContrastD = iniFile.ReadInt(SECTION_DEFAULT, KEY_CONTRAST, DEFAULT_C);
	int nSaturationD = iniFile.ReadInt(SECTION_DEFAULT, KEY_SATURATION, DEFAULT_S);
	int nHueD = iniFile.ReadInt(SECTION_DEFAULT, KEY_HUE, DEFAULT_H);
	int nSharpnessD = iniFile.ReadInt(SECTION_DEFAULT, KEY_SHARPNESS, DEFAULT_SH);
	BOOL bAudioD = iniFile.ReadInt(SECTION_DEFAULT, KEY_AUDIO, DEFAULT_AUDIO);
	BOOL bTitle  = iniFile.ReadInt(SECTION_DEFAULT, KEY_TITLE, DEFAULT_TITLE);
	int  nAudioPacketLength = iniFile.ReadInt(SECTION_DEFAULT, KEY_AUDIO_PACKET, DEFAULT_AUDIO_PACKET);
	BOOL bOptimizeCIFD = iniFile.ReadInt(SECTION_DEFAULT, KEY_OPTIMIZE_CIF, DEFAULT_OPTIMIZE_CIF);
	BOOL bDeinterlaceD = iniFile.ReadInt(SECTION_DEFAULT, KEY_DEINTERLACE, DEFAULT_DEINTERLACE);

	int  vStandard, vFrameRate, vFormat, vWidth, vHeight;
	int  nBright, nContrast, nSaturation, nHue, nSharpness;
	BOOL bAudio, bOptimizeCIF, bDeinterlace;

	TF_TwGetChannelDetail fTwGetChannelDetail = (TF_TwGetChannelDetail)GetProcAddress(m_hSdk, "TwGetChannelDetail");
	if(fTwGetChannelDetail == NULL) {
		return FALSE;
	}
	TF_TwSetAudioPara fTwSetAudioPara = (TF_TwSetAudioPara)GetProcAddress(m_hSdk, "TwSetAudioPara");
	
	TChannelDesc   chlDesc;
	CField2*	   field2=NULL;
	
	bField2 = FALSE;
	CChannel::InitSound();

	if(fTwSetAudioPara) {
		fTwSetAudioPara(NULL, apPacketLength, nAudioPacketLength);
	}
	
	if((iReorder==2) && fTwChangeChannelId) {
		//ͨ˳:ʵʱлģʽЧ
		TBoardDesc	 bodDesc;
		int n, m = 0, vi=0, vc, vd, vid;
		vector<int>	 vComposite[viCompositeMax];
		for(i=0; i<nBoard; i++) {
			ZeroMemory(&bodDesc, sizeof(bodDesc));
			fTwGetBoardDetail(fTwGetBoardHandle(i), &bodDesc);
			ZeroMemory(&devDesc, sizeof(devDesc));
			fTwGetDeviceDetail(fTwGetDeviceHandle(bodDesc.nFirstDevice), &devDesc);
			if((DEVICEID(devDesc.HardwareId)<0x6810) || (DEVICEID(devDesc.HardwareId)>0x6813)) {
				continue;
			}

			//ֻTW6816
			vd = devDesc.DeviceNumber;
			vid = -1;
			for(n=bodDesc.nFirstDevice; n<bodDesc.nFirstDevice+bodDesc.nDeviceCount; n++) {
				ZeroMemory(&devDesc, sizeof(devDesc));
				fTwGetDeviceDetail(fTwGetDeviceHandle(n), &devDesc);
				if(devDesc.DeviceNumber != vd) {
					for(vi=0; vi<(int)viCompositeMax; vi++) {
						for(m=0; m<(int)vComposite[vi].size(); m++) {
							fTwChangeChannelId(vComposite[vi][m], vid);
							vid++;
						}
						vComposite[vi].clear();
					}
				}
				for(m=devDesc.nFirstSubDevice; m<devDesc.nFirstSubDevice+devDesc.nSubDevice; m++) {
					ZeroMemory(&subDesc, sizeof(subDesc));
					fTwGetSubDeviceDetail(fTwGetSubDeviceHandle(m), &subDesc);
					vc = subDesc.nFirstChannel;
					if(vid==-1) {
						vid = vc;
					}
					for(vi=0; vi<(int)viCompositeMax; vi++) {
						if(subDesc.VideoInputMask & INPUT_MASK(vi)) {
							vComposite[vi].push_back(vc);
							vc++;
						}
					}
				}
			}
			for(vi=0; vi<(int)viCompositeMax; vi++) {
				for(m=0; m<(int)vComposite[vi].size(); m++) {
					fTwChangeChannelId(vComposite[vi][m], vid);
					vid++;
				}
				vComposite[vi].clear();
			}
		}
		iReorder = 0;
	}
	if(iReorder) {
		int m = 0;
		for(m=0; m<4; m++) {
			for(j=0; j<(ULONG)nDevice; j++) {
				ZeroMemory(&subDesc, sizeof(TSubDeviceDesc));
				
				hSubDev = fTwGetSubDeviceHandle(j);
				fTwGetSubDeviceDetail(hSubDev, &subDesc);
				if((subDesc.VideoInputMask & (1<<m)) == 0) {
					continue;
				}
				i = subDesc.nFirstChannel + m;
				
				hChannel = fTwChannelOpen(i);
				channel = new CChannel();
				m_chlList.push_back(channel);
				m_chlShow.push_back(channel);
				channel->Init(hChannel, i);
				
				field2 = NULL;
				ZeroMemory(&chlDesc, sizeof(chlDesc));
				if(fTwGetChannelDetail(hChannel, &chlDesc)) {
					ZeroMemory(&subDesc, sizeof(subDesc));
					hSubDev = fTwGetSubDeviceHandle(chlDesc.nSubDeviceId);
					if(fTwGetSubDeviceDetail(hSubDev, &subDesc)) {
						if(subDesc.bField2) {
							bField2 = TRUE;
							field2 = new CField2();
							field2->Init(hChannel, i);
						}
					}
				}
				m_fd2List.push_back(field2);
			}
		}
	}
	else {
		for(i=0; i<nChannel; i++) {
			hChannel = fTwChannelOpen(i);
			channel = new CChannel();
			m_chlList.push_back(channel);
			m_chlShow.push_back(channel);
			channel->Init(hChannel, i);
			
			field2 = NULL;
			ZeroMemory(&chlDesc, sizeof(chlDesc));
			if(fTwGetChannelDetail(hChannel, &chlDesc)) {
				ZeroMemory(&subDesc, sizeof(subDesc));
				hSubDev = fTwGetSubDeviceHandle(chlDesc.nSubDeviceId);
				if(fTwGetSubDeviceDetail(hSubDev, &subDesc)) {
					if(subDesc.bField2) {
						bField2 = TRUE;
						field2 = new CField2();
						field2->Init(hChannel, i);
					}
				}
			}
			m_fd2List.push_back(field2);
		}
	}

	for(j=0; j<m_chlList.size(); j++) {
		i = m_chlList[j]->ChannelId();
		hChannel = m_chlList[j]->ChannelHandle();
		field2 = m_fd2List[j];

		ZeroMemory(&chlDesc, sizeof(chlDesc));
		ZeroMemory(&devDesc, sizeof(devDesc));
		if(fTwGetChannelDetail(hChannel, &chlDesc)) {
			hDevice = fTwGetDeviceHandle(chlDesc.nDeviceId);
			fTwGetDeviceDetail(hDevice, &devDesc);
		}

		strInfo.Format(SECTION_CHANNEL, i);
		vStandard = iniFile.ReadInt(strInfo, KEY_STANDARD, vStandardD);
		vFrameRate = iniFile.ReadInt(strInfo, KEY_FRAMERATE, vFrameRateD);
		vFormat = iniFile.ReadInt(strInfo, KEY_PIXELFORMAT, vFormatD);
		vWidth  = iniFile.ReadInt(strInfo, KEY_WIDTH, vWidthD);
		vHeight = iniFile.ReadInt(strInfo, KEY_HEIGHT, vHeightD);
		nBright = iniFile.ReadInt(strInfo, KEY_BRIGHT, nBrightD);
		nContrast = iniFile.ReadInt(strInfo, KEY_CONTRAST, nContrastD);
		nSaturation = iniFile.ReadInt(strInfo, KEY_SATURATION, nSaturationD);
		nHue    = iniFile.ReadInt(strInfo, KEY_HUE, nHueD);
		nSharpness  = iniFile.ReadInt(strInfo, KEY_SHARPNESS, nSharpnessD);
		bAudio  = iniFile.ReadInt(strInfo, KEY_AUDIO, bAudioD);
		bOptimizeCIF= iniFile.ReadInt(strInfo, KEY_OPTIMIZE_CIF, bOptimizeCIFD);
		bDeinterlace= iniFile.ReadInt(strInfo, KEY_DEINTERLACE, bDeinterlaceD);

		if(field2 != NULL) {
			vHeight = (vStandard==vsStandardPAL) ? min(vHeight, 288) : min(vHeight, 240);
		}

		m_fTwSetVideoPara(hChannel, vpStandard, vStandard);
		m_fTwSetVideoPara(hChannel, vpPixelFormat, vFormat);
		m_fTwSetVideoPara(hChannel, vpWidth, vWidth);
		m_fTwSetVideoPara(hChannel, vpHeight, vHeight);
		m_fTwSetVideoPara(hChannel, vpFrameRate, vFrameRate);
		m_fTwSetVideoPara(hChannel, vpBrightness, nBright);
		m_fTwSetVideoPara(hChannel, vpContrast, nContrast);
		m_fTwSetVideoPara(hChannel, vpSaturation, nSaturation);
		m_fTwSetVideoPara(hChannel, vpHue, nHue);
		m_fTwSetVideoPara(hChannel, vpSharpness, nSharpness);
		if(bOptimizeCIF) {
			m_fTwSetVideoPara(hChannel, vpOptimizedCIF, !field2 && (DEVICEID(devDesc.HardwareId)!=0x6864));
		}

		rcClient.left  = 1 + nWidth*(j%k);
		rcClient.top   = 1 + nHeight*(j/k);
		rcClient.right = min(rcClient.left + nWidth - 1, nRightMax);
		rcClient.bottom= rcClient.top + nHeight - 1;
		
		m_chlList[j]->CreateWnd(rcClient, this, i);

		if(field2 != NULL) {
			vFrameRate = iniFile.ReadInt(strInfo, KEY_FRAMERATE2, vFrameRateD);
			vFormat = iniFile.ReadInt(strInfo, KEY_PIXELFORMAT2, vFormatD);
			vWidth  = iniFile.ReadInt(strInfo, KEY_WIDTH2, vWidthD);
			vHeight = iniFile.ReadInt(strInfo, KEY_HEIGHT2, vHeightD);
			if(field2 != NULL) {
				vHeight = (vStandard==vsStandardPAL) ? min(vHeight, 288) : min(vHeight, 240);
			}
			m_fTwSetVideoPara(hChannel, vpPixelFormat2, vFormat);
			m_fTwSetVideoPara(hChannel, vpFrameRate2, vFrameRate);
			m_fTwSetVideoPara(hChannel, vpWidth2, vWidth);
			m_fTwSetVideoPara(hChannel, vpHeight2, vHeight);
		}

		StartChannel(i, bAudio, bDeinterlace);
	}

	if(k*k > nChannel) {
		CLogoWnd* wndLogo = NULL;
		for(i=nChannel; i<k*k; i++) {
			rcClient.left  = 1 + nWidth*(i%k);
			rcClient.top   = 1 + nHeight*(i/k);
			rcClient.right = min(rcClient.left + nWidth - 1, nRightMax);
			rcClient.bottom= rcClient.top + nHeight - 1;
			
			wndLogo = new CLogoWnd();
			wndLogo->CreateWnd(rcClient, this, 0);
			m_wndLogo.push_back(wndLogo);
		}
	}
		
	m_bLarge = FALSE;
	m_fd2Dlg.Init();
	GetDlgItem(IDC_BTN_FIELD2)->EnableWindow(bField2);

	SetCurrentChannel(0);
	SetTimer(TIMER_UPDATESTATUS, 1000, NULL);
	SetTimer(TIMER_CHECKSIGNAL,  1000, NULL);
	EnableTitle(bTitle);

	m_nAudio = -1;
	((CButton*)GetDlgItem(IDC_CHECK_AUDIO))->SetCheck(FALSE);

	return TRUE;
}

inline int CTW68XXDlg::MapPixelFormat(int vFormat)
{
	switch(vFormat) {
	case vpfYUV422Interspersed:
		vFormat = PIX_FMT_YUV422;
		break;
	case vpfYUV420Planar:
		vFormat = PIX_FMT_YUV420P;
		break;
	case vpfYUV411Interspersed:
		//vFormat = PIX_FMT_Y41P;
#if(DISPLAY_Y41P_TO_YUY2)
		vFormat = PIX_FMT_YUV422;
#else
		vFormat = PIX_FMT_YUV420P;
#endif
		break;
	case vpfRGB15Alpha:
		vFormat = PIX_FMT_RGB555;
		break;
	case vpfRGB16:
		vFormat = PIX_FMT_RGB565;
		break;
	default:
		vFormat = PIX_FMT_YUV422;
	}

	return vFormat;
}

BOOL CTW68XXDlg::StartChannel(int channel, BOOL bAudio, BOOL bDeinterlace)
{
	TF_TwStartVideoCapture fTwStartVideoCapture = (TF_TwStartVideoCapture)GetProcAddress(m_hSdk, "TwStartVideoCapture");
	if(fTwStartVideoCapture == NULL) {
		return FALSE;
	}
	
	TF_TwStartAudioCapture fTwStartAudioCapture = (TF_TwStartAudioCapture)GetProcAddress(m_hSdk, "TwStartAudioCapture");
	if(fTwStartAudioCapture == NULL) {
		return FALSE;
	}

	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(m_hSdk, "TwGetVideoPara");
	if(fTwGetVideoPara == NULL) {
		return FALSE;
	}
	
	channel = ChannelIndex(channel);
	if(channel < 0) {
		return FALSE;
	}
	
	LONG vWidth = DEFAULT_WIDTH;
	LONG vHeight= DEFAULT_HEIGHT;
	HANDLE hChannel = m_chlList[channel]->ChannelHandle();
	LONG vFormat= 0,  vStandard=vsStandardPAL, vOptimizeCIF=0;
	BOOL bY41P = FALSE;

	fTwGetVideoPara(hChannel, vpWidth, &vWidth);
	fTwGetVideoPara(hChannel, vpHeight, &vHeight);
	fTwGetVideoPara(hChannel, vpPixelFormat, &vFormat);
	fTwGetVideoPara(hChannel, vpStandard, &vStandard);
	fTwGetVideoPara(hChannel, vpOptimizedCIF, &vOptimizeCIF);
	bY41P = (vFormat == vpfYUV411Interspersed);
	vFormat = MapPixelFormat(vFormat);

	if(bDeinterlace) {
		bDeinterlace = (vStandard==vsStandardPAL) ? (vHeight>288) : (vHeight>240);
		if(!bDeinterlace) {
			bDeinterlace = (vOptimizeCIF==TRUE);
		}
	}

	m_chlList[channel]->Close();
	m_chlList[channel]->Open(vWidth, vHeight, vFormat, bY41P);
	m_chlList[channel]->EnableDeinterlace(bDeinterlace);

	if(bAudio) {
		fTwStartAudioCapture(hChannel);
	}

	if(m_fd2List[channel] != NULL) {
		fTwGetVideoPara(hChannel, vpWidth2, &vWidth);
		fTwGetVideoPara(hChannel, vpHeight2, &vHeight);
		fTwGetVideoPara(hChannel, vpPixelFormat2, &vFormat);
		bY41P = (vFormat == vpfYUV411Interspersed);
		vFormat = MapPixelFormat(vFormat);
		m_fd2List[channel]->Close();
		m_fd2List[channel]->Open(vWidth, vHeight, vFormat, bY41P);
		if(m_fd2List[channel]->IsRunning()) {
			m_fd2List[channel]->Run(TRUE);
		}
	}
	
	return fTwStartVideoCapture(hChannel);
}

//----------------------------------
// ʼSDK
//----------------------------------
void CTW68XXDlg::UninitSDK()
{
	if(m_hSdk == NULL) {
		return;
	}

	TF_TwStopVideoCapture fTwStopVideoCapture = (TF_TwStopVideoCapture)GetProcAddress(m_hSdk, "TwStopVideoCapture");
	TF_TwStopVideoField2 fTwStopVideoField2 = (TF_TwStopVideoField2)GetProcAddress(m_hSdk, "TwStopVideoField2");
	TF_TwStopAudioCapture fTwStopAudioCapture = (TF_TwStopAudioCapture)GetProcAddress(m_hSdk, "TwStopAudioCapture");
	TF_TwChannelClose fTwChannelClose = (TF_TwChannelClose)GetProcAddress(m_hSdk, "TwChannelClose");
	TF_TwUninitSDK fTwUninitSDK = (TF_TwUninitSDK)GetProcAddress(m_hSdk, "TwUninitSDK");
	CChannel*	channel = NULL;
	CField2*	field2  = NULL;
	HANDLE		hChannel= NULL;

	KillTimer(TIMER_UPDATESTATUS);
	KillTimer(TIMER_CHECKSIGNAL);

	SetWatchDog(FALSE);

	for(UINT i=0; i<m_chlList.size(); i++) {
		channel = m_chlList[i];
		hChannel= channel->ChannelHandle();
		fTwStopVideoField2(hChannel);
		fTwStopVideoCapture(hChannel);
		fTwStopAudioCapture(hChannel);
		fTwChannelClose(hChannel);
	}

	int nCount = 0;
	while(m_bRunning && (nCount<30)) {
		Sleep(100);
		TRACE(TEXT("uninit ....%d\n"), nCount);
		nCount++;
	}
	
	fTwUninitSDK();

	while(m_chlList.size() > 0) {
		channel = m_chlList.back();
		m_chlList.pop_back();
		channel->Save(FALSE);
		delete channel;
		field2 = m_fd2List.back();
		if(field2 != NULL) {
			delete field2;
		}
		m_fd2List.pop_back();
	}

	m_chlShow.clear();
	m_fd2Dlg.ShowWindow(SW_HIDE);
	m_fTwSetVideoPara = NULL;

	m_nAudio = -1;
	m_current= 0;
	CChannel::UninitSound();

	if(m_hSdk != NULL) {
		FreeLibrary(m_hSdk);
		m_hSdk = NULL;
	}

	while(m_wndLogo.size() > 0) {
		m_wndLogo.back()->DestroyWindow();
		delete m_wndLogo.back();
		m_wndLogo.pop_back();
	}
}

void CTW68XXDlg::OnClose()
{
	UninitSDK();
	m_fd2Dlg.DestroyWindow();
	m_sfcLogo.Destroy();

	CDialog::OnOK();
}

void CTW68XXDlg::OnCancel() 
{
}

void CTW68XXDlg::OnOK() 
{
}

void CTW68XXDlg::OnCheckAudio() 
{
	if(m_chlList.size() <= 0) {
		return;
	}

	CString  strPath, strTemp;
	CIniFile iniFile;
	BOOL bAudio = FALSE;
	
	GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
	strPath.ReleaseBuffer();
	iniFile.Create(strPath + OPTION_FILE);
	strTemp.Format(SECTION_CHANNEL, m_chlList[m_current]->ChannelId());
	bAudio = iniFile.ReadInt(strTemp, KEY_AUDIO, DEFAULT_AUDIO);

	TF_TwStartAudioCapture fTwStartAudioCapture = (TF_TwStartAudioCapture)GetProcAddress(m_hSdk, "TwStartAudioCapture");
	TF_TwStopAudioCapture  fTwStopAudioCapture = (TF_TwStopAudioCapture)GetProcAddress(m_hSdk, "TwStopAudioCapture");
	if(fTwStartAudioCapture == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return;
	}
	
	if(m_nAudio >= 0) {
		m_chlShow[m_nAudio]->EnableSound(FALSE);
		if(!bAudio) {
			fTwStopAudioCapture(m_chlShow[m_nAudio]->ChannelHandle());
		}
		SetWatchDog(FALSE);
	}
	if(m_nAudio==m_current) {
		m_nAudio = -1;
	}
	else {
		m_nAudio = m_current;
		m_chlList[m_nAudio]->EnableSound(TRUE);
		if(!bAudio) {
			fTwStartAudioCapture(m_chlShow[m_nAudio]->ChannelHandle());
		}
		SetWatchDog(TRUE);
	}
}

void CTW68XXDlg::OnBtnOption() 
{
	COptionDlg dlgOption;
	dlgOption.DoModal();
	SetCurrentChannel(m_chlList[m_current]->ChannelId());
}

void CTW68XXDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(m_fTwSetVideoPara != NULL) {
		if(m_chlShow.size() >0) {
			HANDLE hChannel = m_chlList[m_current]->ChannelHandle();
			CString  strPath;
			CIniFile iniFile;
			
			GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
			strPath.ReleaseBuffer();
			iniFile.Create(strPath + OPTION_FILE);
			strPath.Format(SECTION_CHANNEL, m_chlList[m_current]->ChannelId());

			if(pScrollBar->GetSafeHwnd() == m_sldBright.GetSafeHwnd()) {
				m_fTwSetVideoPara(hChannel, vpBrightness, m_sldBright.GetPos());
				iniFile.WriteInt(strPath, KEY_BRIGHT, m_sldBright.GetPos());
			}
			else if(pScrollBar->GetSafeHwnd() == m_sldContrast.GetSafeHwnd()) {
				m_fTwSetVideoPara(hChannel, vpContrast, m_sldContrast.GetPos());
				iniFile.WriteInt(strPath, KEY_CONTRAST, m_sldContrast.GetPos());
			}
			else if(pScrollBar->GetSafeHwnd() == m_sldSaturation.GetSafeHwnd()) {
				m_fTwSetVideoPara(hChannel, vpSaturation, m_sldSaturation.GetPos());
				iniFile.WriteInt(strPath, KEY_SATURATION, m_sldSaturation.GetPos());
			}
			else if(pScrollBar->GetSafeHwnd() == m_sldHue.GetSafeHwnd()) {
				m_fTwSetVideoPara(hChannel, vpHue, m_sldHue.GetPos());
				iniFile.WriteInt(strPath, KEY_HUE, m_sldHue.GetPos());
			}
			else if(pScrollBar->GetSafeHwnd() == m_sldSharpness.GetSafeHwnd()) {
				m_fTwSetVideoPara(hChannel, vpSharpness, m_sldSharpness.GetPos());
				iniFile.WriteInt(strPath, KEY_SHARPNESS, m_sldSharpness.GetPos());
			}
		}
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CTW68XXDlg::OnBtnDefault() 
{
	if(m_chlList.size() >0) {
		CString  strPath;
		CIniFile iniFile;
		
		GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
		strPath.ReleaseBuffer();
		iniFile.Create(strPath + OPTION_FILE);

		LONG   B = iniFile.ReadInt(SECTION_DEFAULT, KEY_BRIGHT, DEFAULT_B);
		LONG   C = iniFile.ReadInt(SECTION_DEFAULT, KEY_CONTRAST, DEFAULT_C);
		LONG   S = iniFile.ReadInt(SECTION_DEFAULT, KEY_SATURATION, DEFAULT_S);
		LONG   H = iniFile.ReadInt(SECTION_DEFAULT, KEY_HUE, DEFAULT_H);
		LONG   SH= iniFile.ReadInt(SECTION_DEFAULT, KEY_SHARPNESS, DEFAULT_SH);
		
		HANDLE hChannel = m_chlList[m_current]->ChannelHandle();
		m_fTwSetVideoPara(hChannel, vpBrightness, B);
		m_fTwSetVideoPara(hChannel, vpContrast, C);
		m_fTwSetVideoPara(hChannel, vpSaturation, S);
		m_fTwSetVideoPara(hChannel, vpHue, H);
		m_fTwSetVideoPara(hChannel, vpSharpness, SH);
		m_sldBright.SetPos(B);
		m_sldContrast.SetPos(C);
		m_sldSaturation.SetPos(S);
		m_sldHue.SetPos(H);
		m_sldSharpness.SetPos(SH);

		strPath.Format(SECTION_CHANNEL, m_chlList[m_current]->ChannelId());
		iniFile.WriteInt(strPath, KEY_BRIGHT, DEFAULT_B);
		iniFile.WriteInt(strPath, KEY_CONTRAST, DEFAULT_C);
		iniFile.WriteInt(strPath, KEY_SATURATION, DEFAULT_S);
		iniFile.WriteInt(strPath, KEY_HUE, DEFAULT_H);
		iniFile.WriteInt(strPath, KEY_SHARPNESS, DEFAULT_SH);

		FeedWatchDog(FALSE);
	}
}

void CTW68XXDlg::OnBtnApply2all() 
{
	int nBright = m_sldBright.GetPos();
	int nContrast = m_sldContrast.GetPos();
	int nSaturation = m_sldSaturation.GetPos();
	int nHue = m_sldHue.GetPos();
	int nSharpness = m_sldSharpness.GetPos();

	for(UINT i=0; i<m_chlList.size(); i++) {
		HANDLE hChannel = m_chlList[i]->ChannelHandle();
		m_fTwSetVideoPara(hChannel, vpBrightness, nBright);
		m_fTwSetVideoPara(hChannel, vpContrast, nContrast);
		m_fTwSetVideoPara(hChannel, vpSaturation, nSaturation);
		m_fTwSetVideoPara(hChannel, vpHue, nHue);
		m_fTwSetVideoPara(hChannel, vpSharpness, nSharpness);
	}
}

void CTW68XXDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	int cxScreen = GetSystemMetrics(SM_CXSCREEN);
	int cyScreen = GetSystemMetrics(SM_CYSCREEN);

	lpMMI->ptMinTrackSize.x = 920;
	lpMMI->ptMinTrackSize.y = 550;
	lpMMI->ptMaxSize.x		= cxScreen + 10;
	lpMMI->ptMaxSize.y		= cyScreen + 90;
	lpMMI->ptMaxTrackSize.x = cxScreen + 120;
	lpMMI->ptMaxTrackSize.y = cyScreen + 120;
	
	CDialog::OnGetMinMaxInfo(lpMMI);
}

void CTW68XXDlg::UpdateVideoWnds()
{
	int nChannel = (int)m_chlShow.size();
	if(nChannel > 0) {
		CRect rcClient;
		int i;
		ULONG k = 0;

		if(nChannel==1)						{ k = 1; }
		else if(nChannel>1 && nChannel<=4)	{ k = 2; }
		else if(nChannel>4 && nChannel<=9)	{ k = 3; }
		else if(nChannel>9 && nChannel<=16)	{ k = 4; }
		else if(nChannel>16&& nChannel<=25)	{ k = 5; }
		else if(nChannel>25&& nChannel<=36)	{ k = 6; }
		else if(nChannel>26&& nChannel<=49)	{ k = 7; }
		else								{ k = 8; }
		GetClientRect(&rcClient);

		int nWidth = rcClient.Width() / k;
		int nHeight= (rcClient.Height()-65) / k;
		int nRightMax = rcClient.right-1;
		
		for(i=0; i<nChannel; i++) {
			rcClient.left  = 1 + nWidth*(i%k);
			rcClient.top   = 1 + nHeight*(i/k);
			rcClient.right = min(rcClient.left + nWidth - 1, nRightMax);
			rcClient.bottom= rcClient.top + nHeight - 1;
			m_chlShow[i]->MoveVideo(rcClient);
		}

		GetDlgItem(IDC_BTN_2SRCSIZE)->EnableWindow(m_bLarge);
		if(m_bLarge) {
			GetClientRect(&rcClient);
			nWidth = rcClient.Width();
			nHeight= rcClient.Height()-65;
			rcClient.left  = 1;
			rcClient.top   = 1;
			rcClient.right = min(rcClient.left + nWidth - 1, nRightMax);
			rcClient.bottom= rcClient.top + nHeight - 1;
			m_chlList[m_current]->MoveVideo(rcClient);
			for(UINT j=0; j<m_wndLogo.size(); j++) {
				m_wndLogo[j]->ShowWindow(SW_HIDE);
			}
		}
		else if(k*k > m_chlList.size()) {
			for(UINT j=0; j<m_wndLogo.size(); j++,i++) {
				rcClient.left  = 1 + nWidth*(i%k);
				rcClient.top   = 1 + nHeight*(i/k);
				rcClient.right = min(rcClient.left + nWidth - 1, nRightMax);
				rcClient.bottom= rcClient.top + nHeight - 1;
 				m_wndLogo[j]->MoveWindow(rcClient);
 				m_wndLogo[j]->ShowWindow(SW_NORMAL);
			}
		}
	}
}

void CTW68XXDlg::OnRadio4video() 
{
	UINT i;
	UINT nOut = 4;
	UINT nCurrent = (UINT)m_current;
	
	m_chlShow.clear();
	for(i=0; i<m_chlList.size(); i++) {
		m_chlList[i]->ShowVideo(FALSE);
	}
	
	if((m_chlList.size()-nCurrent) >= nOut) {
		for(i=0; i<min(nOut, m_chlList.size()); i++) {
			m_chlShow.push_back(m_chlList[nCurrent+i]);
			m_chlList[nCurrent+i]->ShowVideo(TRUE);
		}
	}
	else if(m_chlList.size() < nOut) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
	}
	else {
		for(i=nCurrent; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
		for(i=0; i<(nOut-(m_chlList.size()-nCurrent)); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
	}

	m_nLayout = 0;
	m_bLarge  = FALSE;

	UpdateVideoWnds();
	m_chlList[m_current]->ShowBorder(TRUE);
}

void CTW68XXDlg::OnRadio9video() 
{
	UINT i;
	UINT nOut = 9;
	UINT nCurrent = (UINT)m_current;
	
	m_chlShow.clear();
	for(i=0; i<m_chlList.size(); i++) {
		m_chlList[i]->ShowVideo(FALSE);
	}
	
	if((m_chlList.size()-nCurrent) >= nOut) {
		for(i=0; i<min(nOut, m_chlList.size()); i++) {
			m_chlShow.push_back(m_chlList[nCurrent+i]);
			m_chlList[nCurrent+i]->ShowVideo(TRUE);
		}
	}
	else if(m_chlList.size() < nOut) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
	}
	else {
		for(i=m_current; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
		for(i=0; i<(nOut-(m_chlList.size()-nCurrent)); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
	}

	m_nLayout = 1;
	m_bLarge  = FALSE;
	
	UpdateVideoWnds();
	m_chlList[m_current]->ShowBorder(TRUE);
}

void CTW68XXDlg::OnRadio16video() 
{
	UINT i;
	UINT nOut = 16;
	UINT nCurrent = (UINT)m_current;
	
	m_chlShow.clear();
	for(i=0; i<m_chlList.size(); i++) {
		m_chlList[i]->ShowVideo(FALSE);
	}
	
	if((m_chlList.size()-nCurrent) >= nOut) {
		for(i=0; i<min(nOut, m_chlList.size()); i++) {
			m_chlShow.push_back(m_chlList[nCurrent+i]);
			m_chlList[nCurrent+i]->ShowVideo(TRUE);
		}
	}
	else if(m_chlList.size() < nOut) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
	}
	else {
		for(i=nCurrent; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
		for(i=0; i<(nOut-(m_chlList.size()-nCurrent)); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
	}

	m_nLayout = 2;
	m_bLarge  = FALSE;
	
	UpdateVideoWnds();
	m_chlList[m_current]->ShowBorder(TRUE);
}

void CTW68XXDlg::OnRadio25video() 
{
	UINT i;
	UINT nOut = 25;
	UINT nCurrent = (UINT)m_current;
	
	m_chlShow.clear();
	for(i=0; i<m_chlList.size(); i++) {
		m_chlList[i]->ShowVideo(FALSE);
	}
	
	if((m_chlList.size()-nCurrent) >= nOut) {
		for(i=0; i<min(nOut, m_chlList.size()); i++) {
			m_chlShow.push_back(m_chlList[nCurrent+i]);
			m_chlList[nCurrent+i]->ShowVideo(TRUE);
		}
	}
	else if(m_chlList.size() < nOut) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
	}
	else {
		for(i=nCurrent; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
		for(i=0; i<(nOut-(m_chlList.size()-nCurrent)); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
	}
	
	m_nLayout = 3;
	m_bLarge  = FALSE;
	
	UpdateVideoWnds();
	m_chlList[m_current]->ShowBorder(TRUE);
}

void CTW68XXDlg::OnRadio36video() 
{
	UINT i;
	UINT nOut = 36;
	UINT nCurrent = (UINT)m_current;
	
	m_chlShow.clear();
	for(i=0; i<m_chlList.size(); i++) {
		m_chlList[i]->ShowVideo(FALSE);
	}
	
	if((m_chlList.size()-nCurrent) >= nOut) {
		for(i=0; i<min(nOut, m_chlList.size()); i++) {
			m_chlShow.push_back(m_chlList[nCurrent+i]);
			m_chlList[nCurrent+i]->ShowVideo(TRUE);
		}
	}
	else if(m_chlList.size() < nOut) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
	}
	else {
		for(i=nCurrent; i<m_chlList.size(); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
		for(i=0; i<(nOut-(m_chlList.size()-nCurrent)); i++) {
			m_chlShow.push_back(m_chlList[i]);
			m_chlList[i]->ShowVideo(TRUE);
		}
	}

	m_nLayout = 4;
	m_bLarge  = FALSE;
	
	UpdateVideoWnds();
	m_chlList[m_current]->ShowBorder(TRUE);
}

void CTW68XXDlg::OnBtnField2() 
{
	m_fd2Dlg.Show();
}

void CTW68XXDlg::OnTimer(UINT_PTR nIDEvent) 
{
	if(nIDEvent == (UINT_PTR)TIMER_UPDATESTATUS) {
		UINT i=0;
		for(i=0; i<m_chlList.size(); i++) {
			m_chlList[i]->UpdateStatus();
		}
		for(i=0; i<m_fd2List.size(); i++) {
			if(m_fd2List[i] != NULL) {
				m_fd2List[i]->UpdateStatus();
			}
		}
	}
	else if(nIDEvent == (UINT_PTR)TIMER_CHECKSIGNAL) {
		for(UINT i=0; i<m_chlList.size(); i++) {
			m_chlList[i]->CheckSignal();
		}
	}
	else if(nIDEvent == (UINT_PTR)TIMER_WATCHDOG)
	{
		FeedWatchDog(TRUE);
	}

	CDialog::OnTimer(nIDEvent);
}

void CTW68XXDlg::OnCheckSave() 
{
	if(m_chlList.size() <= 0) {
		return;
	}
	
	CCopyToDlg dlg(ITEM_CHANNEL, (int)m_chlList.size());
	ULONG  i = 0;
	for(i=0; i<m_chlList.size(); i++) {
		dlg.m_CopyTo[i] = m_chlList[i]->IsSaving();
	}
	if(dlg.DoModal() == IDOK) {
		for(i=0; i<m_chlList.size(); i++) {
			m_chlList[i]->Save(dlg.m_CopyTo[i]);
		}
	}
	((CButton*)GetDlgItem(IDC_CHECK_SAVE))->SetCheck(m_chlList[m_current]->IsSaving());
}

void CTW68XXDlg::EnableTitle(BOOL bEnable)
{
	UINT i=0; 

	for(i=0; i<m_chlList.size(); i++) {
		m_chlList[i]->EnableTitle(bEnable);
	}

	for(i=0; i<m_chlShow.size(); i++) {
		if(m_chlShow[i]->IsVisible()) {
			m_chlShow[i]->ShowTitle(bEnable, TRUE);
		}
	}

	m_fd2Dlg.EnableTitle(bEnable);
}

void CTW68XXDlg::OnBtnSnap() 
{
	if(m_chlList.size() <= 0) {
		return;
	}
	
	m_chlList[m_current]->Snap();
}

void CTW68XXDlg::Rgb24_to_Rgb555(PBYTE rgb555, PBYTE rgb24, int width, int height)
{
	PUSHORT p16 = NULL;

	for(int h=0; h<height; h++) {
		p16 = (PUSHORT)(rgb555 + width*(height-h-1)*2);
		for(int w=0; w<width; w++) {
			*p16 = ((rgb24[2] & 0xF8) << 7)	|
				   ((rgb24[1] & 0xF8) << 2)	|
				   ((rgb24[0] & 0xF8) >> 3);
			p16++;
			rgb24 += 3;
		}
	}
}

BOOL CTW68XXDlg::InitLogo()
{
	CString  strPath;
	HBITMAP  hBitmap = NULL;
	BITMAP   bm;
	PBYTE	 bufLogo = NULL;

	GetModulePath(strPath.GetBuffer(MAX_PATH), MAX_PATH);
	strPath.ReleaseBuffer();

	hBitmap = (HBITMAP)LoadImage(AfxGetInstanceHandle(), 
		strPath + TEXT("logo.bmp"), IMAGE_BITMAP, 0, 0, 
		LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if(!hBitmap) {
		return FALSE;
	}
	
	if(!GetObject((HGDIOBJ)hBitmap, sizeof(BITMAP), &bm)) {
		DeleteObject((HGDIOBJ)hBitmap);
		return FALSE;
	}
	
	try {
		if(FAILED(m_sfcLogo.Create(CField2::m_vOut->GetDDraw(), bm.bmWidth, bm.bmHeight, PIX_FMT_RGB555))) {
			DeleteObject((HGDIOBJ)hBitmap);
			return FALSE;
		}

		bufLogo = new BYTE[bm.bmWidth*bm.bmHeight*2];
		Rgb24_to_Rgb555(bufLogo, (PBYTE)bm.bmBits, bm.bmWidth, bm.bmHeight);
	
		if(FAILED(m_sfcLogo.Draw(bufLogo))) {
			DeleteObject((HGDIOBJ)hBitmap);
			delete[] bufLogo;
			return FALSE;
		}

		DeleteObject((HGDIOBJ)hBitmap);
		delete[] bufLogo;
	}
	catch(...) {
		DeleteObject((HGDIOBJ)hBitmap);
		if(bufLogo) {
			delete[] bufLogo;
		}
		TRACE(TEXT("Load bmp file or create offscreen surface exception!\n"));
		return FALSE;
	}

	return TRUE;
}

void CTW68XXDlg::OnBtn2srcsize() 
{
	CRect rcClient;

	if(!m_bLarge) { return;	}

	TF_TwGetVideoPara fTwGetVideoPara = (TF_TwGetVideoPara)GetProcAddress(m_hSdk, "TwGetVideoPara");
	if(fTwGetVideoPara == NULL) { return; }

	rcClient.left  = 1;
	rcClient.top   = 1;
	fTwGetVideoPara(m_chlList[m_current]->ChannelHandle(), vpWidth, &rcClient.right);
	fTwGetVideoPara(m_chlList[m_current]->ChannelHandle(), vpHeight, &rcClient.bottom);
	rcClient.right+= rcClient.left;
	rcClient.bottom+=rcClient.top;
		
	m_chlList[m_current]->MoveVideo(rcClient);
}

void CTW68XXDlg::OnBtnBlackstripe() 
{
	CBlackStripeDlg dlg;

	dlg.Init(m_hSdk, m_chlList[m_current]->ChannelId());
	dlg.DoModal();
}

void CTW68XXDlg::TestAll(BOOL bStart)
{
	UINT i=0; 
	TF_TwStartVideoCapture fTwStartVideoCapture = (TF_TwStartVideoCapture)GetProcAddress(m_hSdk, "TwStartVideoCapture");
	if(fTwStartVideoCapture == NULL) {
		return;
	}
	
	TF_TwStopVideoCapture fTwStopVideoCapture = (TF_TwStopVideoCapture)GetProcAddress(m_hSdk, "TwStopVideoCapture");
	if(fTwStopVideoCapture == NULL) {
		return;
	}
	
	if(bStart) {
		for(i=0; i<m_chlList.size(); i++) {
			fTwStartVideoCapture(m_chlList[i]->ChannelHandle());
		}
	}
	else {
		for(i=0; i<m_chlList.size(); i++) {
			fTwStopVideoCapture(m_chlList[i]->ChannelHandle());
		}
	}
}

void CTW68XXDlg::OptimizeCIF(LONG iOn)
{
	UINT i=0; 
	TF_TwSetVideoPara fTwSetVideoPara = (TF_TwSetVideoPara)GetProcAddress(m_hSdk, "TwSetVideoPara");
	if(fTwSetVideoPara == NULL) {
		return;
	}
	
	for(i=0; i<m_chlList.size(); i++) {
		fTwSetVideoPara(m_chlList[i]->ChannelHandle(), vpOptimizedCIF1, iOn);
	}
}

#define RST_PIN_0	6
#define RST_PIN_1	7

#define RST_RUN		2
#define RST_STOP	4

void CTW68XXDlg::SetWatchDog(BOOL bEnable)
{
	int i=0; 
	TF_TwGetDeviceCount fTwGetDeviceCount = (TF_TwGetDeviceCount)GetProcAddress(m_hSdk, "TwGetDeviceCount");
	if(fTwGetDeviceCount == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return;
	}

	TF_TwGetDeviceHandle fTwGetDeviceHandle = (TF_TwGetDeviceHandle)GetProcAddress(m_hSdk, "TwGetDeviceHandle");
	if(fTwGetDeviceHandle == NULL) {
		return;
	}

	int nDevice = fTwGetDeviceCount();
	if(nDevice <= 0) {
		AfxMessageBox(IDS_ERR_NODEVICE);
		return;
	}

	TF_TwGPIOEnableOutput fTwGPIOEnableOutput = (TF_TwGPIOEnableOutput)GetProcAddress(m_hSdk, "TwGPIOEnableOutput");
	TF_TwGPIOSetBits fTwGPIOSetBits = (TF_TwGPIOSetBits)GetProcAddress(m_hSdk, "TwGPIOSetBits");
	TF_TwGPIOOpen  fTwGPIOOpen = (TF_TwGPIOOpen)GetProcAddress(m_hSdk, "TwGPIOOpen");
	HANDLE hGpio = NULL;
	ULONG  bitSet = 0;

	for(i=0; i<nDevice; i++)
	{
		hGpio = fTwGPIOOpen(fTwGetDeviceHandle(i));
		fTwGPIOEnableOutput(hGpio, RST_PIN_0, 2, TRUE);

		bitSet = 0;
		fTwGPIOSetBits(hGpio, RST_PIN_1, 1, &bitSet);

		bitSet = 1;
		fTwGPIOSetBits(hGpio, RST_PIN_0, 1, &bitSet);
		Sleep(1);
		bitSet = 0;
		fTwGPIOSetBits(hGpio, RST_PIN_0, 1, &bitSet);
		Sleep(10);

		for(int j=0; j<(bEnable?RST_RUN:RST_STOP); j++)
		{
			bitSet = 1;
			fTwGPIOSetBits(hGpio, RST_PIN_1, 1, &bitSet);
			Sleep(1);
			bitSet = 0;
			fTwGPIOSetBits(hGpio, RST_PIN_1, 1, &bitSet);
			Sleep(1);
		}

		bitSet = 1;
		fTwGPIOSetBits(hGpio, RST_PIN_1, 1, &bitSet);

		bitSet = 1;
		fTwGPIOSetBits(hGpio, RST_PIN_0, 1, &bitSet);
		Sleep(1);
		bitSet = 0;
		fTwGPIOSetBits(hGpio, RST_PIN_0, 1, &bitSet);
		Sleep(10);
	}

	if(bEnable)
	{
		SetTimer(TIMER_WATCHDOG, 1000, NULL);
	}
	else
	{
		KillTimer(TIMER_WATCHDOG);
	}
}

void CTW68XXDlg::FeedWatchDog(BOOL bFeed)
{
	int i=0; 
	TF_TwGetDeviceCount fTwGetDeviceCount = (TF_TwGetDeviceCount)GetProcAddress(m_hSdk, "TwGetDeviceCount");
	if(fTwGetDeviceCount == NULL) {
		AfxMessageBox(IDS_ERR_SDKFILE);
		return;
	}

	TF_TwGetDeviceHandle fTwGetDeviceHandle = (TF_TwGetDeviceHandle)GetProcAddress(m_hSdk, "TwGetDeviceHandle");
	if(fTwGetDeviceHandle == NULL) {
		return;
	}

	int nDevice = fTwGetDeviceCount();
	if(nDevice <= 0) {
		AfxMessageBox(IDS_ERR_NODEVICE);
		return;
	}

	TF_TwGPIOEnableOutput fTwGPIOEnableOutput = (TF_TwGPIOEnableOutput)GetProcAddress(m_hSdk, "TwGPIOEnableOutput");
	TF_TwGPIOSetBits fTwGPIOSetBits = (TF_TwGPIOSetBits)GetProcAddress(m_hSdk, "TwGPIOSetBits");
	TF_TwGPIOOpen  fTwGPIOOpen = (TF_TwGPIOOpen)GetProcAddress(m_hSdk, "TwGPIOOpen");
	HANDLE hGpio = NULL;
	ULONG  bitSet = 0;

	for(i=0; i<nDevice; i++)
	{
		hGpio = fTwGPIOOpen(fTwGetDeviceHandle(i));
		fTwGPIOEnableOutput(hGpio, RST_PIN_0, 2, TRUE);
		bitSet = 1;
		fTwGPIOSetBits(hGpio, RST_PIN_1, 1, &bitSet);
		Sleep(1);
		bitSet = 0;
		fTwGPIOSetBits(hGpio, RST_PIN_1, 1, &bitSet);
	}

	if(!bFeed)
	{
		KillTimer(TIMER_WATCHDOG);
	}
}