#if !defined(AFX_FIELD2DLG_H__71B04FDD_8ED5_4E0F_BD4E_8DD7E3439D0B__INCLUDED_)
#define AFX_FIELD2DLG_H__71B04FDD_8ED5_4E0F_BD4E_8DD7E3439D0B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Filed2Dlg.h : header file
//

#include "Field2.h"
#include <vector>
using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CField2Dlg dialog

class CField2Dlg : public CDialog
{
// Construction
public:
	CField2Dlg(vector<CField2*>& chlList, CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CField2Dlg)
	enum { IDD = IDD_FIELD2_DIALOG };
	int		m_nLayout;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CField2Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	vector<CField2*>&	m_chlList;
	vector<CField2*>	m_chlShow;
	int					m_current;
	BOOL				m_bLarge;
	CRect				m_rcNormal;

	// Generated message map functions
	//{{AFX_MSG(CField2Dlg)
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnClose();
	afx_msg void OnCheckStartfield2();
	afx_msg void OnRadio4video();
	afx_msg void OnRadio9video();
	afx_msg void OnRadio16video();
	afx_msg void OnRadio25video();
	afx_msg void OnRadio36video();
	virtual BOOL OnInitDialog();
	afx_msg void OnMove(int x, int y);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void Init();
	void UpdateVideoWnds();
	void EnableTitle(BOOL bEnable);
	int	 ChannelIndex(int chlId) {
		for(ULONG i=0; i<m_chlList.size(); i++) {
			if(m_chlList[i] && (m_chlList[i]->ChannelId()==chlId)) {
				return i;
			}
		}
		return -1;
	}

	void SetCurrentChannel(int channel);
	VOID ShowVideoWnds(int channel, BOOL bShow);
	void Show();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FIELD2DLG_H__71B04FDD_8ED5_4E0F_BD4E_8DD7E3439D0B__INCLUDED_)
