/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6803.h
 *  @brief		Ƶ豸CDev6803֧TW6803 : for TW6802B TS function
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#if !defined(__DEV6803_H_)
#define __DEV6803_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DevBase.h"
#include "DmaProgram.h"
#include "SAA7113.h"

class CDev6803 : public CDevBase, CDmap6801, public CSAA7113
{
public:
	CDev6803();
	virtual ~CDev6803();

	virtual long PrepareRun();
	virtual BOOL OnData();
	virtual long OnIrq();
	virtual BOOL Run();
	virtual BOOL Stop();
	virtual long HasSignal();
	virtual int  DeviceType() {return DEV_video;}
	virtual BOOL Build(int iField, TvDmaProgInfo* dpi);
	virtual void SetSize(int width, int height);
	void		 OnGpint();

protected:
	//麯ʼʼ豸
	virtual BOOL OnAllocResource();
	virtual BOOL OnFreeResource();
	virtual BOOL OnOpen();
	virtual BOOL OnClose();
	
	//豸ƺ
	void  EnableFfifoIrq(UCHAR enable);
	void  EnablePciIrq(UCHAR enable);

	//DMAP
	void  SetDmapAddr(ULONG phyAddr);
	void  EnableDmaIrq(UCHAR enable);
	virtual void  RunDmap(UCHAR run);

	ULONG		m_tkSignal;
	vector<PMemBlock>	m_listDmap;

	int			m_nFirstLineStart;
	int			m_nLineStart;
};

#endif // !defined(__DEV6803_H_)
