/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6864sg.h
 *  @brief		豸CDev6864sg2f֧TW6864 scatter gather -- two fieldģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/07/28
 ***************************************************************************************
 */

#if !defined(__DEV6864SG2F_H_)
#define __DEV6864SG2F_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Dev6864sg.h"

class CDev6864sg2f : public CDev6864sg  
{
public:
	CDev6864sg2f();
	virtual ~CDev6864sg2f();

	virtual long OnIrq();
	virtual BOOL OnData();
	virtual void SetFrameRate(void* ctx);
	virtual BOOL InsertSample(CSample* pSample);
	
protected:
	virtual BOOL OnAllocResource();
	virtual BOOL OnFreeResource();
	virtual void Build(void* ctx);
	
	vector<CSample*>	m_bufField2;	//Field2ʹõbuffer
	CSample*			m_splFiled2;
};

#endif // !defined(__DEV6864SG2F_H_)
