/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6869.h
 *  @brief		豸CDev6869ʵ֣֧TW6869
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/07/10
 ***************************************************************************************
 */

#if !defined(__DEV6869_H_)
#define __DEV6869_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DevBase.h"

#define P_TW6869						((CTW6869*)m_pParent)

class CDev6869 : public CDevBase  
{
public:
	CDev6869();
	virtual ~CDev6869();

	virtual long PrepareRun();
	virtual BOOL OnData();
	virtual long HasSignal();
	virtual int  DeviceType() {return DEV_video;}
	virtual BOOL HasChannelRunning(ULONG runFlag); 
	virtual BOOL OnDmaError(ULONG status1, ULONG status2, PVOID ctx);
	virtual void OnDmaTimeOut();
	virtual void SetFrameRate(void* ctx) {}
	int			 BadFrames(){ return m_iBadFrames; }
	void		 ResetBadFrames() { m_iBadFrames=0; }

protected:
	//麯ʼʼ豸
	virtual BOOL OnFreeResource();
	virtual BOOL OnClose();
	virtual void Build(void* ctx) {}
	virtual void SetParameters(void* ctx, BOOL bSignalLast) {}

	//DMAP
	virtual void RunDmap(UCHAR run);

	int			m_iCheck;
	int			m_iBadFrames;
	LONGLONG	m_tkLast;
};

#endif // !defined(__DEV6869_H_)
