/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6869sg.h
 *  @brief		豸CDev6869sg֧TW6869 scatter gatherģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		20010/07/10
 ***************************************************************************************
 */

#if !defined(__DEV6869SG_H_)
#define __DEV6869SG_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Dev6869.h"

class CDev6869sg : public CDev6869  
{
public:
	CDev6869sg();
	virtual ~CDev6869sg();

	virtual long OnIrq();
	virtual void SetFrameRate(void* ctx);

protected:
	virtual BOOL OnAllocResource();
	virtual BOOL OnFreeResource();
	virtual BOOL OnOpen();
	virtual void Build(void* ctx);
	virtual void Build(PMemBlock pmbPageTable, PMemBlock pmbBuffer, ULONG offset, void* ctx);
	virtual UINT LastDmaBuffer(BOOL isPageB, ULONG dmap);

	vector<PMemBlock> m_memDmapP;
	vector<PMemBlock> m_memDmapB;
};

#endif // !defined(__DEV6869SG_H_)
