/**
 ***************************************************************************************
 *  Copyright (C) 2010, Techwell
 *  All rights reserved.
 *
 *  @file 		Dev6869sg2f.h
 *  @brief		豸CDev6869sg2f֧TW6869 scatter gather -- two fieldģʽ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2010/07/10
 ***************************************************************************************
 */

#if !defined(__DEV6869SG2F_H_)
#define __DEV6869SG2F_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Dev6869sg.h"

class CDev6869sg2f : public CDev6869sg  
{
public:
	CDev6869sg2f();
	virtual ~CDev6869sg2f();

	virtual long OnIrq();
	virtual BOOL OnData();
	virtual void SetFrameRate(void* ctx);
	virtual BOOL InsertSample(CSample* pSample);
	
protected:
	virtual BOOL OnAllocResource();
	virtual BOOL OnFreeResource();
	virtual void Build(void* ctx);
	virtual void Build(PMemBlock pmbPageTable, PMemBlock pmbBuffer, ULONG offset, void* ctx);
	
	vector<CSample*>	m_bufField2;	//Field2ʹõbuffer
	CSample*			m_splFiled2;
	ULONG				m_iDmapPreview;
};

#endif // !defined(__DEV6869SG2F_H_)
