/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		Gpio680x.h
 *  @brief		CGpio680X,֧TW680x GPIO
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/06
 ***************************************************************************************
 */

#if !defined(__GPIO680X_H__)
#define __GPIO680X_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Gpio.h"

class CGpio680X : public CGpio  
{
public:
	CGpio680X(CMemRange* pMem) : m_pMem(pMem) {};
	virtual ~CGpio680X() {};

	virtual bool InitGpio(TGpioMode mode);
	virtual bool InitGpio(PVOID pMem) { m_pMem=(CMemRange*)pMem; return true; }
	virtual bool EnableGpioOutput(bool enable, int gpio, int bits);
	virtual bool SetGpioBits(int gpio, int bits, ULONG* value);
	virtual bool GetGpioBits(int gpio, int bits, ULONG* pValue);

protected:
	CMemRange* m_pMem;
};

#endif // !defined(__GPIO680X_H__)
