/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		MemRange.h
 *  @brief		ĴдCMemRange
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#if !defined(__MemRange_H_)
#define __MemRange_H_

class CMemRange  
{
public:
	CMemRange();
	virtual ~CMemRange();

	VOID init(HANDLE hDev, PVOID addrBase, PVOID procBase, ULONG len, BOOL isDirectAccess) {
				m_hDev=hDev;m_pPBase=addrBase;m_pVBase=procBase;m_uLen=len;m_bDirectAccess=isDirectAccess;
			}
	VOID uninit(){m_hDev=NULL;m_pPBase=NULL;m_pVBase=NULL;m_uLen=0;}

	UCHAR inb(ULONG Offset=0);
	VOID inb(ULONG Offset, PUCHAR buf, ULONG count);
	VOID outb(ULONG Offset, UCHAR data);
	VOID outb(ULONG Offset, PUCHAR buf, ULONG count);

	USHORT inw(ULONG Offset=0);
	VOID inw(ULONG Offset, PUSHORT buf, ULONG count);
	VOID outw(ULONG Offset, USHORT data);
	VOID outw(ULONG Offset, PUSHORT buf, ULONG count);

	ULONG ind(ULONG Offset=0);
	VOID ind(ULONG Offset, PULONG buf, ULONG count);
	VOID outd(ULONG Offset, ULONG data);
	VOID outd(ULONG Offset, PULONG buf, ULONG count);

	PVOID CpuBaseAddress(){return m_pPBase;}
	PVOID GetBaseAddress(){return m_pVBase;}
	ULONG GetLength(){return m_uLen;}

	VOID  Dump2File(LPCTSTR szFile);
protected:
	HANDLE m_hDev;
	PVOID  m_pPBase;
	PVOID  m_pVBase;
	ULONG  m_uLen;
	BOOL   m_bDirectAccess;
};

#endif // !defined(__MemoryRange_H_)
