/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TSource.cpp
 *  @brief		Դ߳CTSourceʵ : ɼƵƵݷй
 *				ûָ豸ֹͣ
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/06/25
 ***************************************************************************************
 */

#include "stdafx.h"
#include "TSource.h"
#include "DevBase.h"
#include "PlgvSource.h"
#include <mmsystem.h>

#define SOURCE_TIMEOUT	5

int CTSource::m_nCount = 0;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTSource::CTSource()
{
	m_nIndex = m_nCount;
	m_nCount++;
}

CTSource::~CTSource()
{
}

void CTSource::AppendDevice(CDevBase* dev)
{
	for(UINT i=0; i<m_devList.size(); i++) {
		if(m_devList[i] == dev) {
			return;
		}
	}

	m_devList.push_back(dev);
}

//-----------------------------------------------------
//̴߳
//-----------------------------------------------------
void CTSource::OnCreate()
{
	//sourceȼԱⵥɼʱͼֻɵص
	//Ҳȱ㣬CPUʺܸʱӰѹplugincallbacḳ߳
	//ֱеRaw bufferռѹOSDȴ
	//ЭĽǽsource߳ȼᵽߣ߳ȼҲ

	SetThreadPriority(m_hThread, THREAD_PRIORITY_ABOVE_NORMAL);
}

//-----------------------------------------------------
//ɼ̹߳׼
//-----------------------------------------------------
UINT CTSource::DoWork()
{
	DWORD dwWait = 0;
	CDevBase*	 dev	 = NULL;
	BOOL		 bExit   = FALSE;
	UINT		 i;

	for(i=0; i<m_devList.size(); i++) {
		//m_devList[i]->ModifyEvt(DataEvent());
	}

	while(!bExit) {
		dwWait = WaitForMultipleObjects(EVT_NUM, m_hEvt, FALSE, SOURCE_TIMEOUT);
		bExit = IsExit();
		if(bExit || (dwWait == (WAIT_OBJECT_0+EVT_EXIT))) {
			break;
		}
		Run();
		ResetEvent(m_hEvt[EVT_DATA]);
	}

	//ֹͣƵ豸
	for(i=0; i<m_devList.size(); i++) {
		dev = m_devList[i];
		dev->UpdateState();
		if(dev->GetState()==DEVSTAT_idle) continue;

		//ֹͣ豸
		dev->Stop();
		_trace(TEXT("[Ϣ]CTSource::DoWorkֹͣ(slot %d0豸%d)\n"), 
			dev->Parent()->CardInfo()->nSlot, dev->Parent()->DeviceInfo().DeviceNumber);
	}

	return 0;
}

//--------------------------------------------------
// ߳Ҫ
//--------------------------------------------------
UINT CTSource::Run()
{
	CDevBase*	dev	= NULL;
	UINT		i;
	UINT		uRet = 0;
	long		state = 0, retIrq;

	//ַƵ豸¼
	for(i=0; i<m_devList.size(); i++) {
		dev = m_devList[i];
		state = dev->GetState();
		if((dev==NULL) || (state==DEVSTAT_idle)) continue;

		//IRQ
		try {
			retIrq = dev->OnIrq();
			if(retIrq < 0) { continue; }
 		}
 		catch(...) {
			_trace(TEXT("[쳣]CTSource::Run豸%d OnIrq쳣\n"), i);
		}

		//ͣ豸豸״̬Ϊready run
		dev->Pause(TRUE);
	}

	for(i=0; i<m_devList.size(); i++) {
		dev = m_devList[i];
		state = dev->GetState();
		if((dev==NULL) || (state==DEVSTAT_idle)) continue;
		
		//ַ豸ɼ
		dev->OnData();
	}
	
	//ֹͣûָƵͨɼ
	for(i=0; i<m_devList.size(); i++) {
		dev = m_devList[i];
		if(dev==NULL) continue;

		//豸״̬
		dev->UpdateState();
		switch(dev->GetState()) {
		case DEVSTAT_readystop :
		{
			//ֹͣ豸
			dev->Stop();
			_trace(TEXT("[Ϣ]CTSource::Runûָ(slot %d0豸%d)ֹͣ\n"), 
				dev->Parent()->CardInfo()->nSlot, dev->Parent()->DeviceInfo().DeviceNumber);
			break;
		}
		case DEVSTAT_readyrun :
			if(dev->PrepareRun()) {
				dev->Run();
			}
			break;
		case DEVSTAT_paused :
			if(dev->Pause(FALSE) < 0) {
				uRet = 1;
			}
			break;
		default: 
			continue;
			break;
		}
	}

	return uRet;
}

//-----------------------------------------------------
//source߳˳׼
//-----------------------------------------------------
UINT CTSource::OnExit()
{
	_trace(TEXT("[Ϣ]CTSource߳%dȫ˳\n"), m_nIndex);
	return 0;
}
