/**
 ***************************************************************************************
 *  Copyright (C) 2009, Techwell
 *  All rights reserved.
 *
 *  @file 		TW6801.h
 *  @brief		оƬCTW6801֧TW6801,TW6804
 *
 *  @version	0.0.0.1
 *  @author		liran
 *  @date		2009/03/31
 ***************************************************************************************
 */

#ifndef __TW6801_H_
#define __TW6801_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Chipset.h"
#include "I2C680X.h"
#include "Gpio680X.h"

class CTW6801 : public CChipset
{
public:
	CTW6801();
	virtual ~CTW6801();

	virtual HANDLE	  GetI2C();
	virtual HANDLE	  GetGPIO();
	virtual BOOL	  CreateDevices();

protected:
	virtual BOOL	  OnInit();
	virtual BOOL	  OnUninit();
	virtual BOOL	  OnOpen();
	virtual BOOL	  OnOpen(PDeviceCapability devCaps, int iDev, int iType);
	virtual BOOL	  OnClose();
	virtual LONG	  Devices(int devType);

	CI2C*	m_i2c;
	CGpio*	m_gpio;
};

#endif //__TW6801_H_